# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import ap_manager
class assigned_ap_managers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-access-points - based on the path /access-points/access-point/assigned-ap-managers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Wireless manager(s) this AP is assigned to. eg. Primary
Secondary, Tertiary etc.
  """
  __slots__ = ('_path_helper', '_extmethods', '__ap_manager',)

  _yang_name = 'assigned-ap-managers'
  _yang_namespace = 'http://openconfig.net/yang/wifi/access-points'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ap_manager = YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['access-points', 'access-point', 'assigned-ap-managers']

  def _get_ap_manager(self):
    """
    Getter method for ap_manager, mapped from YANG variable /access_points/access_point/assigned_ap_managers/ap_manager (list)

    YANG Description: Manager(s) this AP is assigned to, referenced by id.
    """
    return self.__ap_manager
      
  def _set_ap_manager(self, v, load=False):
    """
    Setter method for ap_manager, mapped from YANG variable /access_points/access_point/assigned_ap_managers/ap_manager (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ap_manager is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ap_manager() directly.

    YANG Description: Manager(s) this AP is assigned to, referenced by id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ap_manager must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)""",
        })

    self.__ap_manager = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ap_manager(self):
    self.__ap_manager = YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)

  ap_manager = __builtin__.property(_get_ap_manager, _set_ap_manager)


  _pyangbind_elements = OrderedDict([('ap_manager', ap_manager), ])


from . import ap_manager
class assigned_ap_managers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-access-points - based on the path /access-points/access-point/assigned-ap-managers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Wireless manager(s) this AP is assigned to. eg. Primary
Secondary, Tertiary etc.
  """
  __slots__ = ('_path_helper', '_extmethods', '__ap_manager',)

  _yang_name = 'assigned-ap-managers'
  _yang_namespace = 'http://openconfig.net/yang/wifi/access-points'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ap_manager = YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['access-points', 'access-point', 'assigned-ap-managers']

  def _get_ap_manager(self):
    """
    Getter method for ap_manager, mapped from YANG variable /access_points/access_point/assigned_ap_managers/ap_manager (list)

    YANG Description: Manager(s) this AP is assigned to, referenced by id.
    """
    return self.__ap_manager
      
  def _set_ap_manager(self, v, load=False):
    """
    Setter method for ap_manager, mapped from YANG variable /access_points/access_point/assigned_ap_managers/ap_manager (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ap_manager is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ap_manager() directly.

    YANG Description: Manager(s) this AP is assigned to, referenced by id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ap_manager must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)""",
        })

    self.__ap_manager = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ap_manager(self):
    self.__ap_manager = YANGDynClass(base=YANGListType("id",ap_manager.ap_manager, yang_name="ap-manager", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='id', extensions=None), is_container='list', yang_name="ap-manager", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='list', is_config=True)

  ap_manager = __builtin__.property(_get_ap_manager, _set_ap_manager)


  _pyangbind_elements = OrderedDict([('ap_manager', ap_manager), ])


