# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import licenses
class license(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-access-points - based on the path /access-points/access-point/system/license. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for license model
  """
  __slots__ = ('_path_helper', '_extmethods', '__licenses',)

  _yang_name = 'license'
  _yang_namespace = 'http://openconfig.net/yang/wifi/access-points'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__licenses = YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['access-points', 'access-point', 'system', 'license']

  def _get_licenses(self):
    """
    Getter method for licenses, mapped from YANG variable /access_points/access_point/system/license/licenses (container)

    YANG Description: Enclosing container for list of licenses
    """
    return self.__licenses
      
  def _set_licenses(self, v, load=False):
    """
    Setter method for licenses, mapped from YANG variable /access_points/access_point/system/license/licenses (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_licenses is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_licenses() directly.

    YANG Description: Enclosing container for list of licenses
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """licenses must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)""",
        })

    self.__licenses = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_licenses(self):
    self.__licenses = YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)

  licenses = __builtin__.property(_get_licenses, _set_licenses)


  _pyangbind_elements = OrderedDict([('licenses', licenses), ])


from . import licenses
class license(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-access-points - based on the path /access-points/access-point/system/license. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for license model
  """
  __slots__ = ('_path_helper', '_extmethods', '__licenses',)

  _yang_name = 'license'
  _yang_namespace = 'http://openconfig.net/yang/wifi/access-points'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__licenses = YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['access-points', 'access-point', 'system', 'license']

  def _get_licenses(self):
    """
    Getter method for licenses, mapped from YANG variable /access_points/access_point/system/license/licenses (container)

    YANG Description: Enclosing container for list of licenses
    """
    return self.__licenses
      
  def _set_licenses(self, v, load=False):
    """
    Setter method for licenses, mapped from YANG variable /access_points/access_point/system/license/licenses (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_licenses is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_licenses() directly.

    YANG Description: Enclosing container for list of licenses
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """licenses must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)""",
        })

    self.__licenses = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_licenses(self):
    self.__licenses = YANGDynClass(base=licenses.licenses, is_container='container', yang_name="licenses", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/wifi/access-points', defining_module='openconfig-access-points', yang_type='container', is_config=True)

  licenses = __builtin__.property(_get_licenses, _set_licenses)


  _pyangbind_elements = OrderedDict([('licenses', licenses), ])


