# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform - based on the path /components/component/software-module/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for software module components
  """
  __slots__ = ('_path_helper', '_extmethods', '__module_type',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'software-module', 'state']

  def _get_module_type(self):
    """
    Getter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)

    YANG Description: Type of the software module
    """
    return self.__module_type
      
  def _set_module_type(self, v, load=False):
    """
    Setter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_module_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_module_type() directly.

    YANG Description: Type of the software module
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """module_type must be of a type compatible with identityref""",
          'defined-type': "openconfig-platform-software:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)""",
        })

    self.__module_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_module_type(self):
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

  module_type = __builtin__.property(_get_module_type)


  _pyangbind_elements = OrderedDict([('module_type', module_type), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform-common - based on the path /components/component/software-module/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for software module components
  """
  __slots__ = ('_path_helper', '_extmethods', '__module_type',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'software-module', 'state']

  def _get_module_type(self):
    """
    Getter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)

    YANG Description: Type of the software module
    """
    return self.__module_type
      
  def _set_module_type(self, v, load=False):
    """
    Setter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_module_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_module_type() directly.

    YANG Description: Type of the software module
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """module_type must be of a type compatible with identityref""",
          'defined-type': "openconfig-platform-software:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)""",
        })

    self.__module_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_module_type(self):
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

  module_type = __builtin__.property(_get_module_type)


  _pyangbind_elements = OrderedDict([('module_type', module_type), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform - based on the path /components/component/software-module/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for software module components
  """
  __slots__ = ('_path_helper', '_extmethods', '__module_type',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'software-module', 'state']

  def _get_module_type(self):
    """
    Getter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)

    YANG Description: Type of the software module
    """
    return self.__module_type
      
  def _set_module_type(self, v, load=False):
    """
    Setter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_module_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_module_type() directly.

    YANG Description: Type of the software module
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """module_type must be of a type compatible with identityref""",
          'defined-type': "openconfig-platform-software:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)""",
        })

    self.__module_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_module_type(self):
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

  module_type = __builtin__.property(_get_module_type)


  _pyangbind_elements = OrderedDict([('module_type', module_type), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform-common - based on the path /components/component/software-module/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for software module components
  """
  __slots__ = ('_path_helper', '_extmethods', '__module_type',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'software-module', 'state']

  def _get_module_type(self):
    """
    Getter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)

    YANG Description: Type of the software module
    """
    return self.__module_type
      
  def _set_module_type(self, v, load=False):
    """
    Setter method for module_type, mapped from YANG variable /components/component/software_module/state/module_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_module_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_module_type() directly.

    YANG Description: Type of the software module
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """module_type must be of a type compatible with identityref""",
          'defined-type': "openconfig-platform-software:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)""",
        })

    self.__module_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_module_type(self):
    self.__module_type = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE_BUNDLE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'openconfig-platform-software:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}, 'oc-sw-module:USERSPACE_PACKAGE': {'@module': 'openconfig-platform-software', '@namespace': 'http://openconfig.net/yang/platform/software-module'}},), is_leaf=True, yang_name="module-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/software-module', defining_module='openconfig-platform-software', yang_type='identityref', is_config=False)

  module_type = __builtin__.property(_get_module_type)


  _pyangbind_elements = OrderedDict([('module_type', module_type), ])


