# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import lane
class host_lanes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform - based on the path /components/component/transceiver/host-lanes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for host lanes.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lane',)

  _yang_name = 'host-lanes'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'transceiver', 'host-lanes']

  def _get_lane(self):
    """
    Getter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    return self.__lane
      
  def _set_lane(self, v, load=False):
    """
    Setter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lane is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lane() directly.

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lane must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)""",
        })

    self.__lane = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lane(self):
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

  lane = __builtin__.property(_get_lane, _set_lane)


  _pyangbind_elements = OrderedDict([('lane', lane), ])


from . import lane
class host_lanes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform-common - based on the path /components/component/transceiver/host-lanes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for host lanes.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lane',)

  _yang_name = 'host-lanes'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'transceiver', 'host-lanes']

  def _get_lane(self):
    """
    Getter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    return self.__lane
      
  def _set_lane(self, v, load=False):
    """
    Setter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lane is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lane() directly.

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lane must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)""",
        })

    self.__lane = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lane(self):
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

  lane = __builtin__.property(_get_lane, _set_lane)


  _pyangbind_elements = OrderedDict([('lane', lane), ])


from . import lane
class host_lanes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform - based on the path /components/component/transceiver/host-lanes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for host lanes.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lane',)

  _yang_name = 'host-lanes'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'transceiver', 'host-lanes']

  def _get_lane(self):
    """
    Getter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    return self.__lane
      
  def _set_lane(self, v, load=False):
    """
    Setter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lane is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lane() directly.

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lane must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)""",
        })

    self.__lane = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lane(self):
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

  lane = __builtin__.property(_get_lane, _set_lane)


  _pyangbind_elements = OrderedDict([('lane', lane), ])


from . import lane
class host_lanes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform-common - based on the path /components/component/transceiver/host-lanes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for host lanes.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lane',)

  _yang_name = 'host-lanes'
  _yang_namespace = 'http://openconfig.net/yang/platform'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['components', 'component', 'transceiver', 'host-lanes']

  def _get_lane(self):
    """
    Getter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    return self.__lane
      
  def _set_lane(self, v, load=False):
    """
    Setter method for lane, mapped from YANG variable /components/component/transceiver/host_lanes/lane (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lane is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lane() directly.

    YANG Description: List of electrical host lanes, keyed by lane number.
The host lanes of a transceiver constitute its electrical interface
with the host system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lane must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)""",
        })

    self.__lane = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lane(self):
    self.__lane = YANGDynClass(base=YANGListType("lane_number",lane.lane, yang_name="lane", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lane-number', extensions=None), is_container='list', yang_name="lane", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='list', is_config=True)

  lane = __builtin__.property(_get_lane, _set_lane)


  _pyangbind_elements = OrderedDict([('lane', lane), ])


