# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import ethernet_segment
class ethernet_segments(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ethernet-segments - based on the path /ethernet-segments. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top-level container for ethernet segments. An Ethernet Segment
is referenced by a name and an ESI
  """
  __slots__ = ('_path_helper', '_extmethods', '__ethernet_segment',)

  _yang_name = 'ethernet-segments'
  _yang_namespace = 'http://openconfig.net/yang/ethernet-segments'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ethernet_segment = YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['ethernet-segments']

  def _get_ethernet_segment(self):
    """
    Getter method for ethernet_segment, mapped from YANG variable /ethernet_segments/ethernet_segment (list)

    YANG Description: List of Ethernet Segments.
    """
    return self.__ethernet_segment
      
  def _set_ethernet_segment(self, v, load=False):
    """
    Setter method for ethernet_segment, mapped from YANG variable /ethernet_segments/ethernet_segment (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ethernet_segment is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ethernet_segment() directly.

    YANG Description: List of Ethernet Segments.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ethernet_segment must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)""",
        })

    self.__ethernet_segment = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ethernet_segment(self):
    self.__ethernet_segment = YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)

  ethernet_segment = __builtin__.property(_get_ethernet_segment, _set_ethernet_segment)


  _pyangbind_elements = OrderedDict([('ethernet_segment', ethernet_segment), ])


from . import ethernet_segment
class ethernet_segments(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ethernet-segments - based on the path /ethernet-segments. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top-level container for ethernet segments. An Ethernet Segment
is referenced by a name and an ESI
  """
  __slots__ = ('_path_helper', '_extmethods', '__ethernet_segment',)

  _yang_name = 'ethernet-segments'
  _yang_namespace = 'http://openconfig.net/yang/ethernet-segments'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ethernet_segment = YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['ethernet-segments']

  def _get_ethernet_segment(self):
    """
    Getter method for ethernet_segment, mapped from YANG variable /ethernet_segments/ethernet_segment (list)

    YANG Description: List of Ethernet Segments.
    """
    return self.__ethernet_segment
      
  def _set_ethernet_segment(self, v, load=False):
    """
    Setter method for ethernet_segment, mapped from YANG variable /ethernet_segments/ethernet_segment (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ethernet_segment is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ethernet_segment() directly.

    YANG Description: List of Ethernet Segments.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ethernet_segment must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)""",
        })

    self.__ethernet_segment = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ethernet_segment(self):
    self.__ethernet_segment = YANGDynClass(base=YANGListType("name",ethernet_segment.ethernet_segment, yang_name="ethernet-segment", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="ethernet-segment", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ethernet-segments', defining_module='openconfig-ethernet-segments', yang_type='list', is_config=True)

  ethernet_segment = __builtin__.property(_get_ethernet_segment, _set_ethernet_segment)


  _pyangbind_elements = OrderedDict([('ethernet_segment', ethernet_segment), ])


