# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import egress_tracking_
class egress_tracking(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ate-flow - based on the path /flows/flow/ingress-tracking/ingress-tracking/egress-tracking. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Flow statistics grouped by egress tracking filter.
  """
  __slots__ = ('_path_helper', '_extmethods', '__egress_tracking',)

  _yang_name = 'egress-tracking'
  _yang_namespace = 'http://openconfig.net/yang/ate-flow'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__egress_tracking = YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['flows', 'flow', 'ingress-tracking', 'ingress-tracking', 'egress-tracking']

  def _get_egress_tracking(self):
    """
    Getter method for egress_tracking, mapped from YANG variable /flows/flow/ingress_tracking/ingress_tracking/egress_tracking/egress_tracking (list)

    YANG Description: If the ATE is configured to track outgoing frames by a header field,
this list will map values of that header field to the flow statistics
specific to frames that match that value.
    """
    return self.__egress_tracking
      
  def _set_egress_tracking(self, v, load=False):
    """
    Setter method for egress_tracking, mapped from YANG variable /flows/flow/ingress_tracking/ingress_tracking/egress_tracking/egress_tracking (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_egress_tracking is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_egress_tracking() directly.

    YANG Description: If the ATE is configured to track outgoing frames by a header field,
this list will map values of that header field to the flow statistics
specific to frames that match that value.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """egress_tracking must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)""",
        })

    self.__egress_tracking = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_egress_tracking(self):
    self.__egress_tracking = YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)

  egress_tracking = __builtin__.property(_get_egress_tracking)


  _pyangbind_elements = OrderedDict([('egress_tracking', egress_tracking), ])


from . import egress_tracking_
class egress_tracking(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ate-flow - based on the path /flows/flow/ingress-tracking/ingress-tracking/egress-tracking. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Flow statistics grouped by egress tracking filter.
  """
  __slots__ = ('_path_helper', '_extmethods', '__egress_tracking',)

  _yang_name = 'egress-tracking'
  _yang_namespace = 'http://openconfig.net/yang/ate-flow'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__egress_tracking = YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['flows', 'flow', 'ingress-tracking', 'ingress-tracking', 'egress-tracking']

  def _get_egress_tracking(self):
    """
    Getter method for egress_tracking, mapped from YANG variable /flows/flow/ingress_tracking/ingress_tracking/egress_tracking/egress_tracking (list)

    YANG Description: If the ATE is configured to track outgoing frames by a header field,
this list will map values of that header field to the flow statistics
specific to frames that match that value.
    """
    return self.__egress_tracking
      
  def _set_egress_tracking(self, v, load=False):
    """
    Setter method for egress_tracking, mapped from YANG variable /flows/flow/ingress_tracking/ingress_tracking/egress_tracking/egress_tracking (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_egress_tracking is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_egress_tracking() directly.

    YANG Description: If the ATE is configured to track outgoing frames by a header field,
this list will map values of that header field to the flow statistics
specific to frames that match that value.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """egress_tracking must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)""",
        })

    self.__egress_tracking = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_egress_tracking(self):
    self.__egress_tracking = YANGDynClass(base=YANGListType("filter",egress_tracking_.egress_tracking, yang_name="egress-tracking", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='filter', extensions=None), is_container='list', yang_name="egress-tracking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ate-flow', defining_module='openconfig-ate-flow', yang_type='list', is_config=False)

  egress_tracking = __builtin__.property(_get_egress_tracking)


  _pyangbind_elements = OrderedDict([('egress_tracking', egress_tracking), ])


