# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import authenticated_session
class authenticated_sessions(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-interfaces - based on the path /interfaces/interface/ethernet/authenticated-sessions. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top level container for authenticated sessions state data.
  """
  __slots__ = ('_path_helper', '_extmethods', '__authenticated_session',)

  _yang_name = 'authenticated-sessions'
  _yang_namespace = 'http://openconfig.net/yang/interfaces'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__authenticated_session = YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['interfaces', 'interface', 'ethernet', 'authenticated-sessions']

  def _get_authenticated_session(self):
    """
    Getter method for authenticated_session, mapped from YANG variable /interfaces/interface/ethernet/authenticated_sessions/authenticated_session (list)

    YANG Description: The list of authenticated sessions on this device.
    """
    return self.__authenticated_session
      
  def _set_authenticated_session(self, v, load=False):
    """
    Setter method for authenticated_session, mapped from YANG variable /interfaces/interface/ethernet/authenticated_sessions/authenticated_session (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_authenticated_session is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_authenticated_session() directly.

    YANG Description: The list of authenticated sessions on this device.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """authenticated_session must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)""",
        })

    self.__authenticated_session = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_authenticated_session(self):
    self.__authenticated_session = YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)

  authenticated_session = __builtin__.property(_get_authenticated_session)


  _pyangbind_elements = OrderedDict([('authenticated_session', authenticated_session), ])


from . import authenticated_session
class authenticated_sessions(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-interfaces - based on the path /interfaces/interface/ethernet/authenticated-sessions. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top level container for authenticated sessions state data.
  """
  __slots__ = ('_path_helper', '_extmethods', '__authenticated_session',)

  _yang_name = 'authenticated-sessions'
  _yang_namespace = 'http://openconfig.net/yang/interfaces'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__authenticated_session = YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['interfaces', 'interface', 'ethernet', 'authenticated-sessions']

  def _get_authenticated_session(self):
    """
    Getter method for authenticated_session, mapped from YANG variable /interfaces/interface/ethernet/authenticated_sessions/authenticated_session (list)

    YANG Description: The list of authenticated sessions on this device.
    """
    return self.__authenticated_session
      
  def _set_authenticated_session(self, v, load=False):
    """
    Setter method for authenticated_session, mapped from YANG variable /interfaces/interface/ethernet/authenticated_sessions/authenticated_session (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_authenticated_session is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_authenticated_session() directly.

    YANG Description: The list of authenticated sessions on this device.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """authenticated_session must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)""",
        })

    self.__authenticated_session = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_authenticated_session(self):
    self.__authenticated_session = YANGDynClass(base=YANGListType("mac",authenticated_session.authenticated_session, yang_name="authenticated-session", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mac', extensions=None), is_container='list', yang_name="authenticated-session", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/interfaces/8021x', defining_module='openconfig-if-8021x', yang_type='list', is_config=False)

  authenticated_session = __builtin__.property(_get_authenticated_session)


  _pyangbind_elements = OrderedDict([('authenticated_session', authenticated_session), ])


