# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import joined_ap
class joined_aps(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ap-manager - based on the path /joined-aps. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top most container for joined-aps.
  """
  __slots__ = ('_path_helper', '_extmethods', '__joined_ap',)

  _yang_name = 'joined-aps'
  _yang_namespace = 'http://openconfig.net/yang/ap-manager'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__joined_ap = YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['joined-aps']

  def _get_joined_ap(self):
    """
    Getter method for joined_ap, mapped from YANG variable /joined_aps/joined_ap (list)

    YANG Description: List of access points that have joined the controller.
    """
    return self.__joined_ap
      
  def _set_joined_ap(self, v, load=False):
    """
    Setter method for joined_ap, mapped from YANG variable /joined_aps/joined_ap (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_joined_ap is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_joined_ap() directly.

    YANG Description: List of access points that have joined the controller.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """joined_ap must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)""",
        })

    self.__joined_ap = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_joined_ap(self):
    self.__joined_ap = YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)

  joined_ap = __builtin__.property(_get_joined_ap)


  _pyangbind_elements = OrderedDict([('joined_ap', joined_ap), ])


from . import joined_ap
class joined_aps(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-ap-manager - based on the path /joined-aps. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Top most container for joined-aps.
  """
  __slots__ = ('_path_helper', '_extmethods', '__joined_ap',)

  _yang_name = 'joined-aps'
  _yang_namespace = 'http://openconfig.net/yang/ap-manager'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__joined_ap = YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['joined-aps']

  def _get_joined_ap(self):
    """
    Getter method for joined_ap, mapped from YANG variable /joined_aps/joined_ap (list)

    YANG Description: List of access points that have joined the controller.
    """
    return self.__joined_ap
      
  def _set_joined_ap(self, v, load=False):
    """
    Setter method for joined_ap, mapped from YANG variable /joined_aps/joined_ap (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_joined_ap is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_joined_ap() directly.

    YANG Description: List of access points that have joined the controller.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """joined_ap must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)""",
        })

    self.__joined_ap = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_joined_ap(self):
    self.__joined_ap = YANGDynClass(base=YANGListType("hostname",joined_ap.joined_ap, yang_name="joined-ap", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='hostname', extensions=None), is_container='list', yang_name="joined-ap", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/ap-manager', defining_module='openconfig-ap-manager', yang_type='list', is_config=False)

  joined_ap = __builtin__.property(_get_joined_ap)


  _pyangbind_elements = OrderedDict([('joined_ap', joined_ap), ])


