# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import linecard_descriptor
class linecard_descriptors(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the terminal-device's list of compatible linecard
component and its associated modes and mode descriptors compatibility
matrix.
  """
  __slots__ = ('_path_helper', '_extmethods', '__linecard_descriptor',)

  _yang_name = 'linecard-descriptors'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__linecard_descriptor = YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors']

  def _get_linecard_descriptor(self):
    """
    Getter method for linecard_descriptor, mapped from YANG variable /linecard_descriptors/linecard_descriptor (list)

    YANG Description: List of linecard components supported by the terminal-device.
The operational mode provides a platform-defined summary
of information such as symbol rate, modulation, pulse
shaping, etc.
    """
    return self.__linecard_descriptor
      
  def _set_linecard_descriptor(self, v, load=False):
    """
    Setter method for linecard_descriptor, mapped from YANG variable /linecard_descriptors/linecard_descriptor (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_linecard_descriptor is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_linecard_descriptor() directly.

    YANG Description: List of linecard components supported by the terminal-device.
The operational mode provides a platform-defined summary
of information such as symbol rate, modulation, pulse
shaping, etc.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """linecard_descriptor must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__linecard_descriptor = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_linecard_descriptor(self):
    self.__linecard_descriptor = YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  linecard_descriptor = __builtin__.property(_get_linecard_descriptor)


  _pyangbind_elements = OrderedDict([('linecard_descriptor', linecard_descriptor), ])


from . import linecard_descriptor
class linecard_descriptors(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the terminal-device's list of compatible linecard
component and its associated modes and mode descriptors compatibility
matrix.
  """
  __slots__ = ('_path_helper', '_extmethods', '__linecard_descriptor',)

  _yang_name = 'linecard-descriptors'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__linecard_descriptor = YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors']

  def _get_linecard_descriptor(self):
    """
    Getter method for linecard_descriptor, mapped from YANG variable /linecard_descriptors/linecard_descriptor (list)

    YANG Description: List of linecard components supported by the terminal-device.
The operational mode provides a platform-defined summary
of information such as symbol rate, modulation, pulse
shaping, etc.
    """
    return self.__linecard_descriptor
      
  def _set_linecard_descriptor(self, v, load=False):
    """
    Setter method for linecard_descriptor, mapped from YANG variable /linecard_descriptors/linecard_descriptor (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_linecard_descriptor is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_linecard_descriptor() directly.

    YANG Description: List of linecard components supported by the terminal-device.
The operational mode provides a platform-defined summary
of information such as symbol rate, modulation, pulse
shaping, etc.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """linecard_descriptor must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__linecard_descriptor = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_linecard_descriptor(self):
    self.__linecard_descriptor = YANGDynClass(base=YANGListType("component_descriptor_id",linecard_descriptor.linecard_descriptor, yang_name="linecard-descriptor", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='component-descriptor-id', extensions=None), is_container='list', yang_name="linecard-descriptor", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  linecard_descriptor = __builtin__.property(_get_linecard_descriptor)


  _pyangbind_elements = OrderedDict([('linecard_descriptor', linecard_descriptor), ])


