# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import compatible_transceiver
class compatible_transceivers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the set of transceiver component which are compatible
with the described linecard component.
  """
  __slots__ = ('_path_helper', '_extmethods', '__compatible_transceiver',)

  _yang_name = 'compatible-transceivers'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__compatible_transceiver = YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers']

  def _get_compatible_transceiver(self):
    """
    Getter method for compatible_transceiver, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver (list)

    YANG Description: List of transceiver descriptor ids.
    """
    return self.__compatible_transceiver
      
  def _set_compatible_transceiver(self, v, load=False):
    """
    Setter method for compatible_transceiver, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_compatible_transceiver is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_compatible_transceiver() directly.

    YANG Description: List of transceiver descriptor ids.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """compatible_transceiver must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__compatible_transceiver = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_compatible_transceiver(self):
    self.__compatible_transceiver = YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  compatible_transceiver = __builtin__.property(_get_compatible_transceiver)


  _pyangbind_elements = OrderedDict([('compatible_transceiver', compatible_transceiver), ])


from . import compatible_transceiver
class compatible_transceivers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the set of transceiver component which are compatible
with the described linecard component.
  """
  __slots__ = ('_path_helper', '_extmethods', '__compatible_transceiver',)

  _yang_name = 'compatible-transceivers'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__compatible_transceiver = YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers']

  def _get_compatible_transceiver(self):
    """
    Getter method for compatible_transceiver, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver (list)

    YANG Description: List of transceiver descriptor ids.
    """
    return self.__compatible_transceiver
      
  def _set_compatible_transceiver(self, v, load=False):
    """
    Setter method for compatible_transceiver, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_compatible_transceiver is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_compatible_transceiver() directly.

    YANG Description: List of transceiver descriptor ids.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """compatible_transceiver must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__compatible_transceiver = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_compatible_transceiver(self):
    self.__compatible_transceiver = YANGDynClass(base=YANGListType("transceiver_descriptor_id",compatible_transceiver.compatible_transceiver, yang_name="compatible-transceiver", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='transceiver-descriptor-id', extensions=None), is_container='list', yang_name="compatible-transceiver", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  compatible_transceiver = __builtin__.property(_get_compatible_transceiver)


  _pyangbind_elements = OrderedDict([('compatible_transceiver', compatible_transceiver), ])


