# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import constrained_compatible_mode
class constrained_compatible_modes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers/compatible-transceiver/constrained-compatible-modes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the set of operatational-modes, present in the terminal-
device manifest, which are compatible with the described transceiver
component within the linecard component.
  """
  __slots__ = ('_path_helper', '_extmethods', '__constrained_compatible_mode',)

  _yang_name = 'constrained-compatible-modes'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__constrained_compatible_mode = YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers', 'compatible-transceiver', 'constrained-compatible-modes']

  def _get_constrained_compatible_mode(self):
    """
    Getter method for constrained_compatible_mode, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/constrained_compatible_modes/constrained_compatible_mode (list)

    YANG Description: List of operational modes supported by the target transceiver.
    """
    return self.__constrained_compatible_mode
      
  def _set_constrained_compatible_mode(self, v, load=False):
    """
    Setter method for constrained_compatible_mode, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/constrained_compatible_modes/constrained_compatible_mode (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_constrained_compatible_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_constrained_compatible_mode() directly.

    YANG Description: List of operational modes supported by the target transceiver.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """constrained_compatible_mode must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__constrained_compatible_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_constrained_compatible_mode(self):
    self.__constrained_compatible_mode = YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  constrained_compatible_mode = __builtin__.property(_get_constrained_compatible_mode)


  _pyangbind_elements = OrderedDict([('constrained_compatible_mode', constrained_compatible_mode), ])


from . import constrained_compatible_mode
class constrained_compatible_modes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers/compatible-transceiver/constrained-compatible-modes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Indicates the set of operatational-modes, present in the terminal-
device manifest, which are compatible with the described transceiver
component within the linecard component.
  """
  __slots__ = ('_path_helper', '_extmethods', '__constrained_compatible_mode',)

  _yang_name = 'constrained-compatible-modes'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__constrained_compatible_mode = YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers', 'compatible-transceiver', 'constrained-compatible-modes']

  def _get_constrained_compatible_mode(self):
    """
    Getter method for constrained_compatible_mode, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/constrained_compatible_modes/constrained_compatible_mode (list)

    YANG Description: List of operational modes supported by the target transceiver.
    """
    return self.__constrained_compatible_mode
      
  def _set_constrained_compatible_mode(self, v, load=False):
    """
    Setter method for constrained_compatible_mode, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/constrained_compatible_modes/constrained_compatible_mode (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_constrained_compatible_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_constrained_compatible_mode() directly.

    YANG Description: List of operational modes supported by the target transceiver.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """constrained_compatible_mode must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)""",
        })

    self.__constrained_compatible_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_constrained_compatible_mode(self):
    self.__constrained_compatible_mode = YANGDynClass(base=YANGListType("mode_id",constrained_compatible_mode.constrained_compatible_mode, yang_name="constrained-compatible-mode", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='mode-id', extensions=None), is_container='list', yang_name="constrained-compatible-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='list', is_config=False)

  constrained_compatible_mode = __builtin__.property(_get_constrained_compatible_mode)


  _pyangbind_elements = OrderedDict([('constrained_compatible_mode', constrained_compatible_mode), ])


