# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers/compatible-transceiver/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Static features or properties which characterize the
component descriptor.
  """
  __slots__ = ('_path_helper', '_extmethods', '__transceiver_descriptor_id',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__transceiver_descriptor_id = YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers', 'compatible-transceiver', 'state']

  def _get_transceiver_descriptor_id(self):
    """
    Getter method for transceiver_descriptor_id, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/state/transceiver_descriptor_id (string)

    YANG Description: String rerference of the system vendor defined transciever
component descriptor id.
    """
    return self.__transceiver_descriptor_id
      
  def _set_transceiver_descriptor_id(self, v, load=False):
    """
    Setter method for transceiver_descriptor_id, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/state/transceiver_descriptor_id (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_transceiver_descriptor_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_transceiver_descriptor_id() directly.

    YANG Description: String rerference of the system vendor defined transciever
component descriptor id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """transceiver_descriptor_id must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)""",
        })

    self.__transceiver_descriptor_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_transceiver_descriptor_id(self):
    self.__transceiver_descriptor_id = YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)

  transceiver_descriptor_id = __builtin__.property(_get_transceiver_descriptor_id)


  _pyangbind_elements = OrderedDict([('transceiver_descriptor_id', transceiver_descriptor_id), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /linecard-descriptors/linecard-descriptor/compatible-transceivers/compatible-transceiver/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Static features or properties which characterize the
component descriptor.
  """
  __slots__ = ('_path_helper', '_extmethods', '__transceiver_descriptor_id',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__transceiver_descriptor_id = YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['linecard-descriptors', 'linecard-descriptor', 'compatible-transceivers', 'compatible-transceiver', 'state']

  def _get_transceiver_descriptor_id(self):
    """
    Getter method for transceiver_descriptor_id, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/state/transceiver_descriptor_id (string)

    YANG Description: String rerference of the system vendor defined transciever
component descriptor id.
    """
    return self.__transceiver_descriptor_id
      
  def _set_transceiver_descriptor_id(self, v, load=False):
    """
    Setter method for transceiver_descriptor_id, mapped from YANG variable /linecard_descriptors/linecard_descriptor/compatible_transceivers/compatible_transceiver/state/transceiver_descriptor_id (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_transceiver_descriptor_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_transceiver_descriptor_id() directly.

    YANG Description: String rerference of the system vendor defined transciever
component descriptor id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """transceiver_descriptor_id must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)""",
        })

    self.__transceiver_descriptor_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_transceiver_descriptor_id(self):
    self.__transceiver_descriptor_id = YANGDynClass(base=str, is_leaf=True, yang_name="transceiver-descriptor-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='string', is_config=False)

  transceiver_descriptor_id = __builtin__.property(_get_transceiver_descriptor_id)


  _pyangbind_elements = OrderedDict([('transceiver_descriptor_id', transceiver_descriptor_id), ])


