# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class counters(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/aft-summaries/ipv4-unicast/protocols/protocol/state/counters. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for aft entry counters
  """
  __slots__ = ('_path_helper', '_extmethods', '__aft_entries',)

  _yang_name = 'counters'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv4-unicast', 'protocols', 'protocol', 'state', 'counters']

  def _get_aft_entries(self):
    """
    Getter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)

    YANG Description: Total number of entries in the aft.
    """
    return self.__aft_entries
      
  def _set_aft_entries(self, v, load=False):
    """
    Setter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aft_entries is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aft_entries() directly.

    YANG Description: Total number of entries in the aft.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aft_entries must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)""",
        })

    self.__aft_entries = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aft_entries(self):
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

  aft_entries = __builtin__.property(_get_aft_entries)


  _pyangbind_elements = OrderedDict([('aft_entries', aft_entries), ])


class counters(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/aft-summaries/ipv4-unicast/protocols/protocol/state/counters. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for aft entry counters
  """
  __slots__ = ('_path_helper', '_extmethods', '__aft_entries',)

  _yang_name = 'counters'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv4-unicast', 'protocols', 'protocol', 'state', 'counters']

  def _get_aft_entries(self):
    """
    Getter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)

    YANG Description: Total number of entries in the aft.
    """
    return self.__aft_entries
      
  def _set_aft_entries(self, v, load=False):
    """
    Setter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aft_entries is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aft_entries() directly.

    YANG Description: Total number of entries in the aft.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aft_entries must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)""",
        })

    self.__aft_entries = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aft_entries(self):
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

  aft_entries = __builtin__.property(_get_aft_entries)


  _pyangbind_elements = OrderedDict([('aft_entries', aft_entries), ])


class counters(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/aft-summaries/ipv4-unicast/protocols/protocol/state/counters. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for aft entry counters
  """
  __slots__ = ('_path_helper', '_extmethods', '__aft_entries',)

  _yang_name = 'counters'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv4-unicast', 'protocols', 'protocol', 'state', 'counters']

  def _get_aft_entries(self):
    """
    Getter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)

    YANG Description: Total number of entries in the aft.
    """
    return self.__aft_entries
      
  def _set_aft_entries(self, v, load=False):
    """
    Setter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aft_entries is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aft_entries() directly.

    YANG Description: Total number of entries in the aft.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aft_entries must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)""",
        })

    self.__aft_entries = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aft_entries(self):
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

  aft_entries = __builtin__.property(_get_aft_entries)


  _pyangbind_elements = OrderedDict([('aft_entries', aft_entries), ])


class counters(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/aft-summaries/ipv4-unicast/protocols/protocol/state/counters. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for aft entry counters
  """
  __slots__ = ('_path_helper', '_extmethods', '__aft_entries',)

  _yang_name = 'counters'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv4-unicast', 'protocols', 'protocol', 'state', 'counters']

  def _get_aft_entries(self):
    """
    Getter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)

    YANG Description: Total number of entries in the aft.
    """
    return self.__aft_entries
      
  def _set_aft_entries(self, v, load=False):
    """
    Setter method for aft_entries, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv4_unicast/protocols/protocol/state/counters/aft_entries (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aft_entries is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aft_entries() directly.

    YANG Description: Total number of entries in the aft.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aft_entries must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)""",
        })

    self.__aft_entries = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aft_entries(self):
    self.__aft_entries = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="aft-entries", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='uint64', is_config=False)

  aft_entries = __builtin__.property(_get_aft_entries)


  _pyangbind_elements = OrderedDict([('aft_entries', aft_entries), ])


