# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import protocols
class ipv6_unicast(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/aft-summaries/ipv6-unicast. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for ipv6 aft counts by protocol type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocols',)

  _yang_name = 'ipv6-unicast'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv6-unicast']

  def _get_protocols(self):
    """
    Getter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)

    YANG Description: Enclosing container for a list of protocols
    """
    return self.__protocols
      
  def _set_protocols(self, v, load=False):
    """
    Setter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocols is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocols() directly.

    YANG Description: Enclosing container for a list of protocols
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocols must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)""",
        })

    self.__protocols = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocols(self):
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

  protocols = __builtin__.property(_get_protocols)


  _pyangbind_elements = OrderedDict([('protocols', protocols), ])


from . import protocols
class ipv6_unicast(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/aft-summaries/ipv6-unicast. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for ipv6 aft counts by protocol type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocols',)

  _yang_name = 'ipv6-unicast'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv6-unicast']

  def _get_protocols(self):
    """
    Getter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)

    YANG Description: Enclosing container for a list of protocols
    """
    return self.__protocols
      
  def _set_protocols(self, v, load=False):
    """
    Setter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocols is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocols() directly.

    YANG Description: Enclosing container for a list of protocols
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocols must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)""",
        })

    self.__protocols = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocols(self):
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

  protocols = __builtin__.property(_get_protocols)


  _pyangbind_elements = OrderedDict([('protocols', protocols), ])


from . import protocols
class ipv6_unicast(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/aft-summaries/ipv6-unicast. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for ipv6 aft counts by protocol type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocols',)

  _yang_name = 'ipv6-unicast'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv6-unicast']

  def _get_protocols(self):
    """
    Getter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)

    YANG Description: Enclosing container for a list of protocols
    """
    return self.__protocols
      
  def _set_protocols(self, v, load=False):
    """
    Setter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocols is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocols() directly.

    YANG Description: Enclosing container for a list of protocols
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocols must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)""",
        })

    self.__protocols = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocols(self):
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

  protocols = __builtin__.property(_get_protocols)


  _pyangbind_elements = OrderedDict([('protocols', protocols), ])


from . import protocols
class ipv6_unicast(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/aft-summaries/ipv6-unicast. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for ipv6 aft counts by protocol type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocols',)

  _yang_name = 'ipv6-unicast'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'aft-summaries', 'ipv6-unicast']

  def _get_protocols(self):
    """
    Getter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)

    YANG Description: Enclosing container for a list of protocols
    """
    return self.__protocols
      
  def _set_protocols(self, v, load=False):
    """
    Setter method for protocols, mapped from YANG variable /network_instances/network_instance/afts/aft_summaries/ipv6_unicast/protocols (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocols is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocols() directly.

    YANG Description: Enclosing container for a list of protocols
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocols must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)""",
        })

    self.__protocols = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocols(self):
    self.__protocols = YANGDynClass(base=protocols.protocols, is_container='container', yang_name="protocols", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/aft-summary', defining_module='openconfig-aft-summary', yang_type='container', is_config=False)

  protocols = __builtin__.property(_get_protocols)


  _pyangbind_elements = OrderedDict([('protocols', protocols), ])


