# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import counters
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/ethernet/mac-entry/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state parameters for the Ethernet AFT
entry.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mac_address','__counters','__entry_metadata','__next_hop_group','__next_hop_group_network_instance',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'ethernet', 'mac-entry', 'state']

  def _get_mac_address(self):
    """
    Getter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    return self.__mac_address
      
  def _set_mac_address(self, v, load=False):
    """
    Setter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mac_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mac_address() directly.

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mac_address must be of a type compatible with oc-yang:mac-address""",
          'defined-type': "oc-yang:mac-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)""",
        })

    self.__mac_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mac_address(self):
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)


  def _get_counters(self):
    """
    Getter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)

    YANG Description: Surrounding container for counters.
    """
    return self.__counters
      
  def _set_counters(self, v, load=False):
    """
    Setter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_counters is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_counters() directly.

    YANG Description: Surrounding container for counters.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """counters must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__counters = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_counters(self):
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_entry_metadata(self):
    """
    Getter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)

    YANG Description: Metadata persistently stored with the entry.
    """
    return self.__entry_metadata
      
  def _set_entry_metadata(self, v, load=False):
    """
    Setter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_entry_metadata is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_entry_metadata() directly.

    YANG Description: Metadata persistently stored with the entry.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """entry_metadata must be of a type compatible with binary""",
          'defined-type': "binary",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)""",
        })

    self.__entry_metadata = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_entry_metadata(self):
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)


  def _get_next_hop_group(self):
    """
    Getter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    return self.__next_hop_group
      
  def _set_next_hop_group(self, v, load=False):
    """
    Setter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group() directly.

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)""",
        })

    self.__next_hop_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group(self):
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)


  def _get_next_hop_group_network_instance(self):
    """
    Getter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    return self.__next_hop_group_network_instance
      
  def _set_next_hop_group_network_instance(self, v, load=False):
    """
    Setter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group_network_instance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group_network_instance() directly.

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group_network_instance must be of a type compatible with oc-ni:network-instance-ref""",
          'defined-type': "oc-ni:network-instance-ref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)""",
        })

    self.__next_hop_group_network_instance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group_network_instance(self):
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

  mac_address = __builtin__.property(_get_mac_address)
  counters = __builtin__.property(_get_counters)
  entry_metadata = __builtin__.property(_get_entry_metadata)
  next_hop_group = __builtin__.property(_get_next_hop_group)
  next_hop_group_network_instance = __builtin__.property(_get_next_hop_group_network_instance)


  _pyangbind_elements = OrderedDict([('mac_address', mac_address), ('counters', counters), ('entry_metadata', entry_metadata), ('next_hop_group', next_hop_group), ('next_hop_group_network_instance', next_hop_group_network_instance), ])


from . import counters
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/ethernet/mac-entry/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state parameters for the Ethernet AFT
entry.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mac_address','__counters','__entry_metadata','__next_hop_group','__next_hop_group_network_instance',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'ethernet', 'mac-entry', 'state']

  def _get_mac_address(self):
    """
    Getter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    return self.__mac_address
      
  def _set_mac_address(self, v, load=False):
    """
    Setter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mac_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mac_address() directly.

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mac_address must be of a type compatible with oc-yang:mac-address""",
          'defined-type': "oc-yang:mac-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)""",
        })

    self.__mac_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mac_address(self):
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)


  def _get_counters(self):
    """
    Getter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)

    YANG Description: Surrounding container for counters.
    """
    return self.__counters
      
  def _set_counters(self, v, load=False):
    """
    Setter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_counters is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_counters() directly.

    YANG Description: Surrounding container for counters.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """counters must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__counters = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_counters(self):
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_entry_metadata(self):
    """
    Getter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)

    YANG Description: Metadata persistently stored with the entry.
    """
    return self.__entry_metadata
      
  def _set_entry_metadata(self, v, load=False):
    """
    Setter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_entry_metadata is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_entry_metadata() directly.

    YANG Description: Metadata persistently stored with the entry.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """entry_metadata must be of a type compatible with binary""",
          'defined-type': "binary",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)""",
        })

    self.__entry_metadata = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_entry_metadata(self):
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)


  def _get_next_hop_group(self):
    """
    Getter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    return self.__next_hop_group
      
  def _set_next_hop_group(self, v, load=False):
    """
    Setter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group() directly.

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)""",
        })

    self.__next_hop_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group(self):
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)


  def _get_next_hop_group_network_instance(self):
    """
    Getter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    return self.__next_hop_group_network_instance
      
  def _set_next_hop_group_network_instance(self, v, load=False):
    """
    Setter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group_network_instance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group_network_instance() directly.

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group_network_instance must be of a type compatible with oc-ni:network-instance-ref""",
          'defined-type': "oc-ni:network-instance-ref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)""",
        })

    self.__next_hop_group_network_instance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group_network_instance(self):
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

  mac_address = __builtin__.property(_get_mac_address)
  counters = __builtin__.property(_get_counters)
  entry_metadata = __builtin__.property(_get_entry_metadata)
  next_hop_group = __builtin__.property(_get_next_hop_group)
  next_hop_group_network_instance = __builtin__.property(_get_next_hop_group_network_instance)


  _pyangbind_elements = OrderedDict([('mac_address', mac_address), ('counters', counters), ('entry_metadata', entry_metadata), ('next_hop_group', next_hop_group), ('next_hop_group_network_instance', next_hop_group_network_instance), ])


from . import counters
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/afts/ethernet/mac-entry/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state parameters for the Ethernet AFT
entry.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mac_address','__counters','__entry_metadata','__next_hop_group','__next_hop_group_network_instance',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'ethernet', 'mac-entry', 'state']

  def _get_mac_address(self):
    """
    Getter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    return self.__mac_address
      
  def _set_mac_address(self, v, load=False):
    """
    Setter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mac_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mac_address() directly.

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mac_address must be of a type compatible with oc-yang:mac-address""",
          'defined-type': "oc-yang:mac-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)""",
        })

    self.__mac_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mac_address(self):
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)


  def _get_counters(self):
    """
    Getter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)

    YANG Description: Surrounding container for counters.
    """
    return self.__counters
      
  def _set_counters(self, v, load=False):
    """
    Setter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_counters is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_counters() directly.

    YANG Description: Surrounding container for counters.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """counters must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__counters = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_counters(self):
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_entry_metadata(self):
    """
    Getter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)

    YANG Description: Metadata persistently stored with the entry.
    """
    return self.__entry_metadata
      
  def _set_entry_metadata(self, v, load=False):
    """
    Setter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_entry_metadata is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_entry_metadata() directly.

    YANG Description: Metadata persistently stored with the entry.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """entry_metadata must be of a type compatible with binary""",
          'defined-type': "binary",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)""",
        })

    self.__entry_metadata = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_entry_metadata(self):
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)


  def _get_next_hop_group(self):
    """
    Getter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    return self.__next_hop_group
      
  def _set_next_hop_group(self, v, load=False):
    """
    Setter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group() directly.

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)""",
        })

    self.__next_hop_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group(self):
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)


  def _get_next_hop_group_network_instance(self):
    """
    Getter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    return self.__next_hop_group_network_instance
      
  def _set_next_hop_group_network_instance(self, v, load=False):
    """
    Setter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group_network_instance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group_network_instance() directly.

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group_network_instance must be of a type compatible with oc-ni:network-instance-ref""",
          'defined-type': "oc-ni:network-instance-ref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)""",
        })

    self.__next_hop_group_network_instance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group_network_instance(self):
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

  mac_address = __builtin__.property(_get_mac_address)
  counters = __builtin__.property(_get_counters)
  entry_metadata = __builtin__.property(_get_entry_metadata)
  next_hop_group = __builtin__.property(_get_next_hop_group)
  next_hop_group_network_instance = __builtin__.property(_get_next_hop_group_network_instance)


  _pyangbind_elements = OrderedDict([('mac_address', mac_address), ('counters', counters), ('entry_metadata', entry_metadata), ('next_hop_group', next_hop_group), ('next_hop_group_network_instance', next_hop_group_network_instance), ])


from . import counters
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/afts/ethernet/mac-entry/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state parameters for the Ethernet AFT
entry.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mac_address','__counters','__entry_metadata','__next_hop_group','__next_hop_group_network_instance',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'afts', 'ethernet', 'mac-entry', 'state']

  def _get_mac_address(self):
    """
    Getter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    return self.__mac_address
      
  def _set_mac_address(self, v, load=False):
    """
    Setter method for mac_address, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/mac_address (oc-yang:mac-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mac_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mac_address() directly.

    YANG Description: The outer MAC address of the Ethernet frame that must
be matched for the AFT entry to be utilised.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mac_address must be of a type compatible with oc-yang:mac-address""",
          'defined-type': "oc-yang:mac-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)""",
        })

    self.__mac_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mac_address(self):
    self.__mac_address = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_dict={'pattern': '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'}), is_leaf=True, yang_name="mac-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-yang:mac-address', is_config=False)


  def _get_counters(self):
    """
    Getter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)

    YANG Description: Surrounding container for counters.
    """
    return self.__counters
      
  def _set_counters(self, v, load=False):
    """
    Setter method for counters, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/counters (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_counters is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_counters() directly.

    YANG Description: Surrounding container for counters.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """counters must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__counters = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_counters(self):
    self.__counters = YANGDynClass(base=counters.counters, is_container='container', yang_name="counters", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_entry_metadata(self):
    """
    Getter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)

    YANG Description: Metadata persistently stored with the entry.
    """
    return self.__entry_metadata
      
  def _set_entry_metadata(self, v, load=False):
    """
    Setter method for entry_metadata, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/entry_metadata (binary)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_entry_metadata is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_entry_metadata() directly.

    YANG Description: Metadata persistently stored with the entry.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """entry_metadata must be of a type compatible with binary""",
          'defined-type': "binary",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)""",
        })

    self.__entry_metadata = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_entry_metadata(self):
    self.__entry_metadata = YANGDynClass(base=RestrictedClassType(base_type=YANGBinary, restriction_dict={'length': ['0..8']}), is_leaf=True, yang_name="entry-metadata", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='binary', is_config=False)


  def _get_next_hop_group(self):
    """
    Getter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    return self.__next_hop_group
      
  def _set_next_hop_group(self, v, load=False):
    """
    Setter method for next_hop_group, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group() directly.

    YANG Description: A reference to the next-hop-group that is in use for the entry within
the AFT. Traffic is distributed across the set of next-hops within the
next-hop group according to the weight. This node needs to refer to any
network-instance on the system hence must be absolute.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)""",
        })

    self.__next_hop_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group(self):
    self.__next_hop_group = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='leafref', is_config=False)


  def _get_next_hop_group_network_instance(self):
    """
    Getter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    return self.__next_hop_group_network_instance
      
  def _set_next_hop_group_network_instance(self, v, load=False):
    """
    Setter method for next_hop_group_network_instance, mapped from YANG variable /network_instances/network_instance/afts/ethernet/mac_entry/state/next_hop_group_network_instance (oc-ni:network-instance-ref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_group_network_instance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_group_network_instance() directly.

    YANG Description: The network instance to look up the next-hop-group in. If unspecified,
the next hop group is in the local network instance. The referenced
network-instance must be an existing network instance on the device and
have corresponding entries in the /network-instances/network-instance
list.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_group_network_instance must be of a type compatible with oc-ni:network-instance-ref""",
          'defined-type': "oc-ni:network-instance-ref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)""",
        })

    self.__next_hop_group_network_instance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_group_network_instance(self):
    self.__next_hop_group_network_instance = YANGDynClass(base=str, is_leaf=True, yang_name="next-hop-group-network-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/aft/ni', defining_module='openconfig-aft-network-instance', yang_type='oc-ni:network-instance-ref', is_config=False)

  mac_address = __builtin__.property(_get_mac_address)
  counters = __builtin__.property(_get_counters)
  entry_metadata = __builtin__.property(_get_entry_metadata)
  next_hop_group = __builtin__.property(_get_next_hop_group)
  next_hop_group_network_instance = __builtin__.property(_get_next_hop_group_network_instance)


  _pyangbind_elements = OrderedDict([('mac_address', mac_address), ('counters', counters), ('entry_metadata', entry_metadata), ('next_hop_group', next_hop_group), ('next_hop_group_network_instance', next_hop_group_network_instance), ])


