# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import b_component
class pbb(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for EVPN with PBB PE functionality
for scaling over MPLS,
  """
  __slots__ = ('_path_helper', '_extmethods', '__b_component',)

  _yang_name = 'pbb'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'evpn', 'evpn-instances', 'evpn-instance', 'pbb']

  def _get_b_component(self):
    """
    Getter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    return self.__b_component
      
  def _set_b_component(self, v, load=False):
    """
    Setter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_b_component is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_b_component() directly.

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """b_component must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__b_component = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_b_component(self):
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  b_component = __builtin__.property(_get_b_component, _set_b_component)


  _pyangbind_elements = OrderedDict([('b_component', b_component), ])


from . import b_component
class pbb(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for EVPN with PBB PE functionality
for scaling over MPLS,
  """
  __slots__ = ('_path_helper', '_extmethods', '__b_component',)

  _yang_name = 'pbb'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'evpn', 'evpn-instances', 'evpn-instance', 'pbb']

  def _get_b_component(self):
    """
    Getter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    return self.__b_component
      
  def _set_b_component(self, v, load=False):
    """
    Setter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_b_component is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_b_component() directly.

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """b_component must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__b_component = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_b_component(self):
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  b_component = __builtin__.property(_get_b_component, _set_b_component)


  _pyangbind_elements = OrderedDict([('b_component', b_component), ])


from . import b_component
class pbb(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for EVPN with PBB PE functionality
for scaling over MPLS,
  """
  __slots__ = ('_path_helper', '_extmethods', '__b_component',)

  _yang_name = 'pbb'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'evpn', 'evpn-instances', 'evpn-instance', 'pbb']

  def _get_b_component(self):
    """
    Getter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    return self.__b_component
      
  def _set_b_component(self, v, load=False):
    """
    Setter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_b_component is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_b_component() directly.

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """b_component must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__b_component = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_b_component(self):
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  b_component = __builtin__.property(_get_b_component, _set_b_component)


  _pyangbind_elements = OrderedDict([('b_component', b_component), ])


from . import b_component
class pbb(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for EVPN with PBB PE functionality
for scaling over MPLS,
  """
  __slots__ = ('_path_helper', '_extmethods', '__b_component',)

  _yang_name = 'pbb'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'evpn', 'evpn-instances', 'evpn-instance', 'pbb']

  def _get_b_component(self):
    """
    Getter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    return self.__b_component
      
  def _set_b_component(self, v, load=False):
    """
    Setter method for b_component, mapped from YANG variable /network_instances/network_instance/evpn/evpn_instances/evpn_instance/pbb/b_component (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_b_component is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_b_component() directly.

    YANG Description: List of B-components. The b-component learns and forwards
traffic on the backbone in order to reduce the number of
BGP MAC Advertisement routes by aggregating Customer/Client
MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """b_component must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__b_component = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_b_component(self):
    self.__b_component = YANGDynClass(base=YANGListType("b_component_name",b_component.b_component, yang_name="b-component", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='b-component-name', extensions=None), is_container='list', yang_name="b-component", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  b_component = __builtin__.property(_get_b_component, _set_b_component)


  _pyangbind_elements = OrderedDict([('b_component', b_component), ])


