# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/flex-algorithm/flex-algo-global-attributes/flex-algo-admin-groups/admin-group/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state for admin-groups
  """
  __slots__ = ('_path_helper', '_extmethods', '__admin_group_name','__bit_position',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'flex-algorithm', 'flex-algo-global-attributes', 'flex-algo-admin-groups', 'admin-group', 'state']

  def _get_admin_group_name(self):
    """
    Getter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)

    YANG Description: name for mpls admin-group
    """
    return self.__admin_group_name
      
  def _set_admin_group_name(self, v, load=False):
    """
    Setter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_admin_group_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_admin_group_name() directly.

    YANG Description: name for mpls admin-group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """admin_group_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)""",
        })

    self.__admin_group_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_admin_group_name(self):
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)


  def _get_bit_position(self):
    """
    Getter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    return self.__bit_position
      
  def _set_bit_position(self, v, load=False):
    """
    Setter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bit_position is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bit_position() directly.

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bit_position must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)""",
        })

    self.__bit_position = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bit_position(self):
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

  admin_group_name = __builtin__.property(_get_admin_group_name)
  bit_position = __builtin__.property(_get_bit_position)


  _pyangbind_elements = OrderedDict([('admin_group_name', admin_group_name), ('bit_position', bit_position), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/flex-algorithm/flex-algo-global-attributes/flex-algo-admin-groups/admin-group/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state for admin-groups
  """
  __slots__ = ('_path_helper', '_extmethods', '__admin_group_name','__bit_position',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'flex-algorithm', 'flex-algo-global-attributes', 'flex-algo-admin-groups', 'admin-group', 'state']

  def _get_admin_group_name(self):
    """
    Getter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)

    YANG Description: name for mpls admin-group
    """
    return self.__admin_group_name
      
  def _set_admin_group_name(self, v, load=False):
    """
    Setter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_admin_group_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_admin_group_name() directly.

    YANG Description: name for mpls admin-group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """admin_group_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)""",
        })

    self.__admin_group_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_admin_group_name(self):
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)


  def _get_bit_position(self):
    """
    Getter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    return self.__bit_position
      
  def _set_bit_position(self, v, load=False):
    """
    Setter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bit_position is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bit_position() directly.

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bit_position must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)""",
        })

    self.__bit_position = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bit_position(self):
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

  admin_group_name = __builtin__.property(_get_admin_group_name)
  bit_position = __builtin__.property(_get_bit_position)


  _pyangbind_elements = OrderedDict([('admin_group_name', admin_group_name), ('bit_position', bit_position), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/flex-algorithm/flex-algo-global-attributes/flex-algo-admin-groups/admin-group/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state for admin-groups
  """
  __slots__ = ('_path_helper', '_extmethods', '__admin_group_name','__bit_position',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'flex-algorithm', 'flex-algo-global-attributes', 'flex-algo-admin-groups', 'admin-group', 'state']

  def _get_admin_group_name(self):
    """
    Getter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)

    YANG Description: name for mpls admin-group
    """
    return self.__admin_group_name
      
  def _set_admin_group_name(self, v, load=False):
    """
    Setter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_admin_group_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_admin_group_name() directly.

    YANG Description: name for mpls admin-group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """admin_group_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)""",
        })

    self.__admin_group_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_admin_group_name(self):
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)


  def _get_bit_position(self):
    """
    Getter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    return self.__bit_position
      
  def _set_bit_position(self, v, load=False):
    """
    Setter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bit_position is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bit_position() directly.

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bit_position must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)""",
        })

    self.__bit_position = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bit_position(self):
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

  admin_group_name = __builtin__.property(_get_admin_group_name)
  bit_position = __builtin__.property(_get_bit_position)


  _pyangbind_elements = OrderedDict([('admin_group_name', admin_group_name), ('bit_position', bit_position), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/flex-algorithm/flex-algo-global-attributes/flex-algo-admin-groups/admin-group/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state for admin-groups
  """
  __slots__ = ('_path_helper', '_extmethods', '__admin_group_name','__bit_position',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'flex-algorithm', 'flex-algo-global-attributes', 'flex-algo-admin-groups', 'admin-group', 'state']

  def _get_admin_group_name(self):
    """
    Getter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)

    YANG Description: name for mpls admin-group
    """
    return self.__admin_group_name
      
  def _set_admin_group_name(self, v, load=False):
    """
    Setter method for admin_group_name, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/admin_group_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_admin_group_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_admin_group_name() directly.

    YANG Description: name for mpls admin-group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """admin_group_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)""",
        })

    self.__admin_group_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_admin_group_name(self):
    self.__admin_group_name = YANGDynClass(base=str, is_leaf=True, yang_name="admin-group-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='string', is_config=False)


  def _get_bit_position(self):
    """
    Getter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    return self.__bit_position
      
  def _set_bit_position(self, v, load=False):
    """
    Setter method for bit_position, mapped from YANG variable /network_instances/network_instance/flex_algorithm/flex_algo_global_attributes/flex_algo_admin_groups/admin_group/state/bit_position (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bit_position is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bit_position() directly.

    YANG Description: bit-position value for mpls admin-group. The value
for the admin group is an integer that represents one
of the bit positions in the admin-group bitmask. Values
between 0 and 31 are interpreted as the original limit
of 32 admin groups. Values >=32 are interpreted as
extended admin group values as per RFC7308.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bit_position must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)""",
        })

    self.__bit_position = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bit_position(self):
    self.__bit_position = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bit-position", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/flexalgo', defining_module='openconfig-flexalgo', yang_type='uint32', is_config=False)

  admin_group_name = __builtin__.property(_get_admin_group_name)
  bit_position = __builtin__.property(_get_bit_position)


  _pyangbind_elements = OrderedDict([('admin_group_name', admin_group_name), ('bit_position', bit_position), ])


