# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import named_explicit_paths
from . import tunnels
class constrained_path(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/mpls/lsps/constrained-path. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineered LSPs supporting different
path computation and signaling methods
  """
  __slots__ = ('_path_helper', '_extmethods', '__named_explicit_paths','__tunnels',)

  _yang_name = 'constrained-path'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'lsps', 'constrained-path']

  def _get_named_explicit_paths(self):
    """
    Getter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)

    YANG Description: Enclosing container for the named explicit paths
    """
    return self.__named_explicit_paths
      
  def _set_named_explicit_paths(self, v, load=False):
    """
    Setter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_named_explicit_paths is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_named_explicit_paths() directly.

    YANG Description: Enclosing container for the named explicit paths
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """named_explicit_paths must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__named_explicit_paths = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_named_explicit_paths(self):
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_tunnels(self):
    """
    Getter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)

    YANG Description: Enclosing container for tunnels
    """
    return self.__tunnels
      
  def _set_tunnels(self, v, load=False):
    """
    Setter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_tunnels is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_tunnels() directly.

    YANG Description: Enclosing container for tunnels
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """tunnels must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__tunnels = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_tunnels(self):
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  named_explicit_paths = __builtin__.property(_get_named_explicit_paths, _set_named_explicit_paths)
  tunnels = __builtin__.property(_get_tunnels, _set_tunnels)


  _pyangbind_elements = OrderedDict([('named_explicit_paths', named_explicit_paths), ('tunnels', tunnels), ])


from . import named_explicit_paths
from . import tunnels
class constrained_path(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/mpls/lsps/constrained-path. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineered LSPs supporting different
path computation and signaling methods
  """
  __slots__ = ('_path_helper', '_extmethods', '__named_explicit_paths','__tunnels',)

  _yang_name = 'constrained-path'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'lsps', 'constrained-path']

  def _get_named_explicit_paths(self):
    """
    Getter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)

    YANG Description: Enclosing container for the named explicit paths
    """
    return self.__named_explicit_paths
      
  def _set_named_explicit_paths(self, v, load=False):
    """
    Setter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_named_explicit_paths is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_named_explicit_paths() directly.

    YANG Description: Enclosing container for the named explicit paths
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """named_explicit_paths must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__named_explicit_paths = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_named_explicit_paths(self):
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_tunnels(self):
    """
    Getter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)

    YANG Description: Enclosing container for tunnels
    """
    return self.__tunnels
      
  def _set_tunnels(self, v, load=False):
    """
    Setter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_tunnels is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_tunnels() directly.

    YANG Description: Enclosing container for tunnels
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """tunnels must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__tunnels = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_tunnels(self):
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  named_explicit_paths = __builtin__.property(_get_named_explicit_paths, _set_named_explicit_paths)
  tunnels = __builtin__.property(_get_tunnels, _set_tunnels)


  _pyangbind_elements = OrderedDict([('named_explicit_paths', named_explicit_paths), ('tunnels', tunnels), ])


from . import named_explicit_paths
from . import tunnels
class constrained_path(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/mpls/lsps/constrained-path. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineered LSPs supporting different
path computation and signaling methods
  """
  __slots__ = ('_path_helper', '_extmethods', '__named_explicit_paths','__tunnels',)

  _yang_name = 'constrained-path'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'lsps', 'constrained-path']

  def _get_named_explicit_paths(self):
    """
    Getter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)

    YANG Description: Enclosing container for the named explicit paths
    """
    return self.__named_explicit_paths
      
  def _set_named_explicit_paths(self, v, load=False):
    """
    Setter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_named_explicit_paths is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_named_explicit_paths() directly.

    YANG Description: Enclosing container for the named explicit paths
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """named_explicit_paths must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__named_explicit_paths = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_named_explicit_paths(self):
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_tunnels(self):
    """
    Getter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)

    YANG Description: Enclosing container for tunnels
    """
    return self.__tunnels
      
  def _set_tunnels(self, v, load=False):
    """
    Setter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_tunnels is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_tunnels() directly.

    YANG Description: Enclosing container for tunnels
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """tunnels must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__tunnels = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_tunnels(self):
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  named_explicit_paths = __builtin__.property(_get_named_explicit_paths, _set_named_explicit_paths)
  tunnels = __builtin__.property(_get_tunnels, _set_tunnels)


  _pyangbind_elements = OrderedDict([('named_explicit_paths', named_explicit_paths), ('tunnels', tunnels), ])


from . import named_explicit_paths
from . import tunnels
class constrained_path(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/mpls/lsps/constrained-path. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineered LSPs supporting different
path computation and signaling methods
  """
  __slots__ = ('_path_helper', '_extmethods', '__named_explicit_paths','__tunnels',)

  _yang_name = 'constrained-path'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'lsps', 'constrained-path']

  def _get_named_explicit_paths(self):
    """
    Getter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)

    YANG Description: Enclosing container for the named explicit paths
    """
    return self.__named_explicit_paths
      
  def _set_named_explicit_paths(self, v, load=False):
    """
    Setter method for named_explicit_paths, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/named_explicit_paths (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_named_explicit_paths is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_named_explicit_paths() directly.

    YANG Description: Enclosing container for the named explicit paths
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """named_explicit_paths must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__named_explicit_paths = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_named_explicit_paths(self):
    self.__named_explicit_paths = YANGDynClass(base=named_explicit_paths.named_explicit_paths, is_container='container', yang_name="named-explicit-paths", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_tunnels(self):
    """
    Getter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)

    YANG Description: Enclosing container for tunnels
    """
    return self.__tunnels
      
  def _set_tunnels(self, v, load=False):
    """
    Setter method for tunnels, mapped from YANG variable /network_instances/network_instance/mpls/lsps/constrained_path/tunnels (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_tunnels is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_tunnels() directly.

    YANG Description: Enclosing container for tunnels
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """tunnels must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__tunnels = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_tunnels(self):
    self.__tunnels = YANGDynClass(base=tunnels.tunnels, is_container='container', yang_name="tunnels", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  named_explicit_paths = __builtin__.property(_get_named_explicit_paths, _set_named_explicit_paths)
  tunnels = __builtin__.property(_get_tunnels, _set_tunnels)


  _pyangbind_elements = OrderedDict([('named_explicit_paths', named_explicit_paths), ('tunnels', tunnels), ])


