# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import srlgs
from . import mpls_admin_groups
from . import te_lsp_timers
from . import bandwidth_measurement
class te_global_attributes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/mpls/te-global-attributes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineering global attributes
  """
  __slots__ = ('_path_helper', '_extmethods', '__srlgs','__mpls_admin_groups','__te_lsp_timers','__bandwidth_measurement',)

  _yang_name = 'te-global-attributes'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'te-global-attributes']

  def _get_srlgs(self):
    """
    Getter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)

    YANG Description: Shared risk link groups attributes
    """
    return self.__srlgs
      
  def _set_srlgs(self, v, load=False):
    """
    Setter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlgs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlgs() directly.

    YANG Description: Shared risk link groups attributes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """srlgs must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__srlgs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_srlgs(self):
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_mpls_admin_groups(self):
    """
    Getter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    return self.__mpls_admin_groups
      
  def _set_mpls_admin_groups(self, v, load=False):
    """
    Setter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mpls_admin_groups is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mpls_admin_groups() directly.

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mpls_admin_groups must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mpls_admin_groups = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mpls_admin_groups(self):
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_te_lsp_timers(self):
    """
    Getter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    return self.__te_lsp_timers
      
  def _set_te_lsp_timers(self, v, load=False):
    """
    Setter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_te_lsp_timers is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_te_lsp_timers() directly.

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """te_lsp_timers must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__te_lsp_timers = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_te_lsp_timers(self):
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_bandwidth_measurement(self):
    """
    Getter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    return self.__bandwidth_measurement
      
  def _set_bandwidth_measurement(self, v, load=False):
    """
    Setter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bandwidth_measurement is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bandwidth_measurement() directly.

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bandwidth_measurement must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)""",
        })

    self.__bandwidth_measurement = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bandwidth_measurement(self):
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

  srlgs = __builtin__.property(_get_srlgs, _set_srlgs)
  mpls_admin_groups = __builtin__.property(_get_mpls_admin_groups, _set_mpls_admin_groups)
  te_lsp_timers = __builtin__.property(_get_te_lsp_timers, _set_te_lsp_timers)
  bandwidth_measurement = __builtin__.property(_get_bandwidth_measurement, _set_bandwidth_measurement)


  _pyangbind_elements = OrderedDict([('srlgs', srlgs), ('mpls_admin_groups', mpls_admin_groups), ('te_lsp_timers', te_lsp_timers), ('bandwidth_measurement', bandwidth_measurement), ])


from . import srlgs
from . import mpls_admin_groups
from . import te_lsp_timers
from . import bandwidth_measurement
class te_global_attributes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/mpls/te-global-attributes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineering global attributes
  """
  __slots__ = ('_path_helper', '_extmethods', '__srlgs','__mpls_admin_groups','__te_lsp_timers','__bandwidth_measurement',)

  _yang_name = 'te-global-attributes'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'te-global-attributes']

  def _get_srlgs(self):
    """
    Getter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)

    YANG Description: Shared risk link groups attributes
    """
    return self.__srlgs
      
  def _set_srlgs(self, v, load=False):
    """
    Setter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlgs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlgs() directly.

    YANG Description: Shared risk link groups attributes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """srlgs must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__srlgs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_srlgs(self):
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_mpls_admin_groups(self):
    """
    Getter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    return self.__mpls_admin_groups
      
  def _set_mpls_admin_groups(self, v, load=False):
    """
    Setter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mpls_admin_groups is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mpls_admin_groups() directly.

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mpls_admin_groups must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mpls_admin_groups = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mpls_admin_groups(self):
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_te_lsp_timers(self):
    """
    Getter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    return self.__te_lsp_timers
      
  def _set_te_lsp_timers(self, v, load=False):
    """
    Setter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_te_lsp_timers is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_te_lsp_timers() directly.

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """te_lsp_timers must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__te_lsp_timers = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_te_lsp_timers(self):
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_bandwidth_measurement(self):
    """
    Getter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    return self.__bandwidth_measurement
      
  def _set_bandwidth_measurement(self, v, load=False):
    """
    Setter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bandwidth_measurement is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bandwidth_measurement() directly.

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bandwidth_measurement must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)""",
        })

    self.__bandwidth_measurement = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bandwidth_measurement(self):
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

  srlgs = __builtin__.property(_get_srlgs, _set_srlgs)
  mpls_admin_groups = __builtin__.property(_get_mpls_admin_groups, _set_mpls_admin_groups)
  te_lsp_timers = __builtin__.property(_get_te_lsp_timers, _set_te_lsp_timers)
  bandwidth_measurement = __builtin__.property(_get_bandwidth_measurement, _set_bandwidth_measurement)


  _pyangbind_elements = OrderedDict([('srlgs', srlgs), ('mpls_admin_groups', mpls_admin_groups), ('te_lsp_timers', te_lsp_timers), ('bandwidth_measurement', bandwidth_measurement), ])


from . import srlgs
from . import mpls_admin_groups
from . import te_lsp_timers
from . import bandwidth_measurement
class te_global_attributes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/mpls/te-global-attributes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineering global attributes
  """
  __slots__ = ('_path_helper', '_extmethods', '__srlgs','__mpls_admin_groups','__te_lsp_timers','__bandwidth_measurement',)

  _yang_name = 'te-global-attributes'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'te-global-attributes']

  def _get_srlgs(self):
    """
    Getter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)

    YANG Description: Shared risk link groups attributes
    """
    return self.__srlgs
      
  def _set_srlgs(self, v, load=False):
    """
    Setter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlgs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlgs() directly.

    YANG Description: Shared risk link groups attributes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """srlgs must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__srlgs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_srlgs(self):
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_mpls_admin_groups(self):
    """
    Getter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    return self.__mpls_admin_groups
      
  def _set_mpls_admin_groups(self, v, load=False):
    """
    Setter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mpls_admin_groups is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mpls_admin_groups() directly.

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mpls_admin_groups must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mpls_admin_groups = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mpls_admin_groups(self):
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_te_lsp_timers(self):
    """
    Getter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    return self.__te_lsp_timers
      
  def _set_te_lsp_timers(self, v, load=False):
    """
    Setter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_te_lsp_timers is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_te_lsp_timers() directly.

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """te_lsp_timers must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__te_lsp_timers = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_te_lsp_timers(self):
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_bandwidth_measurement(self):
    """
    Getter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    return self.__bandwidth_measurement
      
  def _set_bandwidth_measurement(self, v, load=False):
    """
    Setter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bandwidth_measurement is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bandwidth_measurement() directly.

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bandwidth_measurement must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)""",
        })

    self.__bandwidth_measurement = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bandwidth_measurement(self):
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

  srlgs = __builtin__.property(_get_srlgs, _set_srlgs)
  mpls_admin_groups = __builtin__.property(_get_mpls_admin_groups, _set_mpls_admin_groups)
  te_lsp_timers = __builtin__.property(_get_te_lsp_timers, _set_te_lsp_timers)
  bandwidth_measurement = __builtin__.property(_get_bandwidth_measurement, _set_bandwidth_measurement)


  _pyangbind_elements = OrderedDict([('srlgs', srlgs), ('mpls_admin_groups', mpls_admin_groups), ('te_lsp_timers', te_lsp_timers), ('bandwidth_measurement', bandwidth_measurement), ])


from . import srlgs
from . import mpls_admin_groups
from . import te_lsp_timers
from . import bandwidth_measurement
class te_global_attributes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/mpls/te-global-attributes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: traffic-engineering global attributes
  """
  __slots__ = ('_path_helper', '_extmethods', '__srlgs','__mpls_admin_groups','__te_lsp_timers','__bandwidth_measurement',)

  _yang_name = 'te-global-attributes'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'mpls', 'te-global-attributes']

  def _get_srlgs(self):
    """
    Getter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)

    YANG Description: Shared risk link groups attributes
    """
    return self.__srlgs
      
  def _set_srlgs(self, v, load=False):
    """
    Setter method for srlgs, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/srlgs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlgs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlgs() directly.

    YANG Description: Shared risk link groups attributes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """srlgs must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__srlgs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_srlgs(self):
    self.__srlgs = YANGDynClass(base=srlgs.srlgs, is_container='container', yang_name="srlgs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_mpls_admin_groups(self):
    """
    Getter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    return self.__mpls_admin_groups
      
  def _set_mpls_admin_groups(self, v, load=False):
    """
    Setter method for mpls_admin_groups, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/mpls_admin_groups (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mpls_admin_groups is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mpls_admin_groups() directly.

    YANG Description: Top-level container for admin-groups configuration
and state
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mpls_admin_groups must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mpls_admin_groups = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mpls_admin_groups(self):
    self.__mpls_admin_groups = YANGDynClass(base=mpls_admin_groups.mpls_admin_groups, is_container='container', yang_name="mpls-admin-groups", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_te_lsp_timers(self):
    """
    Getter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    return self.__te_lsp_timers
      
  def _set_te_lsp_timers(self, v, load=False):
    """
    Setter method for te_lsp_timers, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/te_lsp_timers (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_te_lsp_timers is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_te_lsp_timers() directly.

    YANG Description: Definition for delays associated with setup
and cleanup of TE LSPs
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """te_lsp_timers must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__te_lsp_timers = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_te_lsp_timers(self):
    self.__te_lsp_timers = YANGDynClass(base=te_lsp_timers.te_lsp_timers, is_container='container', yang_name="te-lsp-timers", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_bandwidth_measurement(self):
    """
    Getter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    return self.__bandwidth_measurement
      
  def _set_bandwidth_measurement(self, v, load=False):
    """
    Setter method for bandwidth_measurement, mapped from YANG variable /network_instances/network_instance/mpls/te_global_attributes/bandwidth_measurement (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bandwidth_measurement is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bandwidth_measurement() directly.

    YANG Description: Configuration and operational state parameters related to
how bandwidth utilisation is measured and flooded into the
IGP.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bandwidth_measurement must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)""",
        })

    self.__bandwidth_measurement = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bandwidth_measurement(self):
    self.__bandwidth_measurement = YANGDynClass(base=bandwidth_measurement.bandwidth_measurement, is_container='container', yang_name="bandwidth-measurement", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/rsvp-sr-ext', defining_module='openconfig-rsvp-sr-ext', yang_type='container', is_config=True)

  srlgs = __builtin__.property(_get_srlgs, _set_srlgs)
  mpls_admin_groups = __builtin__.property(_get_mpls_admin_groups, _set_mpls_admin_groups)
  te_lsp_timers = __builtin__.property(_get_te_lsp_timers, _set_te_lsp_timers)
  bandwidth_measurement = __builtin__.property(_get_bandwidth_measurement, _set_bandwidth_measurement)


  _pyangbind_elements = OrderedDict([('srlgs', srlgs), ('mpls_admin_groups', mpls_admin_groups), ('te_lsp_timers', te_lsp_timers), ('bandwidth_measurement', bandwidth_measurement), ])


