# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import config
from . import state
from . import encapsulate_gre
from . import segment_lists
class action(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The forwarding policy action to be applied for
packets matching the rule.
  """
  __slots__ = ('_path_helper', '_extmethods', '__config','__state','__encapsulate_gre','__segment_lists',)

  _yang_name = 'action'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'policy-forwarding', 'policies', 'policy', 'rules', 'rule', 'action']

  def _get_config(self):
    """
    Getter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    return self.__config
      
  def _set_config(self, v, load=False):
    """
    Setter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_config is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_config() directly.

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """config must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__config = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_config(self):
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_encapsulate_gre(self):
    """
    Getter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    return self.__encapsulate_gre
      
  def _set_encapsulate_gre(self, v, load=False):
    """
    Setter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encapsulate_gre is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encapsulate_gre() directly.

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encapsulate_gre must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__encapsulate_gre = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encapsulate_gre(self):
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_segment_lists(self):
    """
    Getter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    return self.__segment_lists
      
  def _set_segment_lists(self, v, load=False):
    """
    Setter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_segment_lists is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_segment_lists() directly.

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """segment_lists must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)""",
        })

    self.__segment_lists = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_segment_lists(self):
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

  config = __builtin__.property(_get_config, _set_config)
  state = __builtin__.property(_get_state)
  encapsulate_gre = __builtin__.property(_get_encapsulate_gre, _set_encapsulate_gre)
  segment_lists = __builtin__.property(_get_segment_lists, _set_segment_lists)


  _pyangbind_elements = OrderedDict([('config', config), ('state', state), ('encapsulate_gre', encapsulate_gre), ('segment_lists', segment_lists), ])


from . import config
from . import state
from . import encapsulate_gre
from . import segment_lists
class action(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The forwarding policy action to be applied for
packets matching the rule.
  """
  __slots__ = ('_path_helper', '_extmethods', '__config','__state','__encapsulate_gre','__segment_lists',)

  _yang_name = 'action'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'policy-forwarding', 'policies', 'policy', 'rules', 'rule', 'action']

  def _get_config(self):
    """
    Getter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    return self.__config
      
  def _set_config(self, v, load=False):
    """
    Setter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_config is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_config() directly.

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """config must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__config = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_config(self):
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_encapsulate_gre(self):
    """
    Getter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    return self.__encapsulate_gre
      
  def _set_encapsulate_gre(self, v, load=False):
    """
    Setter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encapsulate_gre is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encapsulate_gre() directly.

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encapsulate_gre must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__encapsulate_gre = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encapsulate_gre(self):
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_segment_lists(self):
    """
    Getter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    return self.__segment_lists
      
  def _set_segment_lists(self, v, load=False):
    """
    Setter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_segment_lists is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_segment_lists() directly.

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """segment_lists must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)""",
        })

    self.__segment_lists = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_segment_lists(self):
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

  config = __builtin__.property(_get_config, _set_config)
  state = __builtin__.property(_get_state)
  encapsulate_gre = __builtin__.property(_get_encapsulate_gre, _set_encapsulate_gre)
  segment_lists = __builtin__.property(_get_segment_lists, _set_segment_lists)


  _pyangbind_elements = OrderedDict([('config', config), ('state', state), ('encapsulate_gre', encapsulate_gre), ('segment_lists', segment_lists), ])


from . import config
from . import state
from . import encapsulate_gre
from . import segment_lists
class action(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The forwarding policy action to be applied for
packets matching the rule.
  """
  __slots__ = ('_path_helper', '_extmethods', '__config','__state','__encapsulate_gre','__segment_lists',)

  _yang_name = 'action'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'policy-forwarding', 'policies', 'policy', 'rules', 'rule', 'action']

  def _get_config(self):
    """
    Getter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    return self.__config
      
  def _set_config(self, v, load=False):
    """
    Setter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_config is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_config() directly.

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """config must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__config = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_config(self):
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_encapsulate_gre(self):
    """
    Getter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    return self.__encapsulate_gre
      
  def _set_encapsulate_gre(self, v, load=False):
    """
    Setter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encapsulate_gre is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encapsulate_gre() directly.

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encapsulate_gre must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__encapsulate_gre = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encapsulate_gre(self):
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_segment_lists(self):
    """
    Getter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    return self.__segment_lists
      
  def _set_segment_lists(self, v, load=False):
    """
    Setter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_segment_lists is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_segment_lists() directly.

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """segment_lists must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)""",
        })

    self.__segment_lists = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_segment_lists(self):
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

  config = __builtin__.property(_get_config, _set_config)
  state = __builtin__.property(_get_state)
  encapsulate_gre = __builtin__.property(_get_encapsulate_gre, _set_encapsulate_gre)
  segment_lists = __builtin__.property(_get_segment_lists, _set_segment_lists)


  _pyangbind_elements = OrderedDict([('config', config), ('state', state), ('encapsulate_gre', encapsulate_gre), ('segment_lists', segment_lists), ])


from . import config
from . import state
from . import encapsulate_gre
from . import segment_lists
class action(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The forwarding policy action to be applied for
packets matching the rule.
  """
  __slots__ = ('_path_helper', '_extmethods', '__config','__state','__encapsulate_gre','__segment_lists',)

  _yang_name = 'action'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'policy-forwarding', 'policies', 'policy', 'rules', 'rule', 'action']

  def _get_config(self):
    """
    Getter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    return self.__config
      
  def _set_config(self, v, load=False):
    """
    Setter method for config, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/config (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_config is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_config() directly.

    YANG Description: Configuration parameters relating to the forwarding
rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """config must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__config = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_config(self):
    self.__config = YANGDynClass(base=config.config, is_container='container', yang_name="config", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Operational state parameters relating to the
forwarding rule's action.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)


  def _get_encapsulate_gre(self):
    """
    Getter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    return self.__encapsulate_gre
      
  def _set_encapsulate_gre(self, v, load=False):
    """
    Setter method for encapsulate_gre, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/encapsulate_gre (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encapsulate_gre is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encapsulate_gre() directly.

    YANG Description: Packets matching the policy rule should be GRE encapsulated
towards the set of targets defined within the target list. Where
more than one target is specified, or the target subnet expands
to more than one endpoint, packets should be load-balanced across
the destination addresses within the subnets.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encapsulate_gre must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__encapsulate_gre = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encapsulate_gre(self):
    self.__encapsulate_gre = YANGDynClass(base=encapsulate_gre.encapsulate_gre, is_container='container', yang_name="encapsulate-gre", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)


  def _get_segment_lists(self):
    """
    Getter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    return self.__segment_lists
      
  def _set_segment_lists(self, v, load=False):
    """
    Setter method for segment_lists, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/action/segment_lists (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_segment_lists is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_segment_lists() directly.

    YANG Description: A list of SR-TE segment lists that should be applied as an
action within this policy. Where a system selects the SR-TE
policy to be used, the list of segment lists that is specified
should be used as forwarding next-hops.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """segment_lists must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)""",
        })

    self.__segment_lists = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_segment_lists(self):
    self.__segment_lists = YANGDynClass(base=segment_lists.segment_lists, is_container='container', yang_name="segment-lists", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/policy-forwarding/sr-te', defining_module='openconfig-pf-srte', yang_type='container', is_config=True)

  config = __builtin__.property(_get_config, _set_config)
  state = __builtin__.property(_get_state)
  encapsulate_gre = __builtin__.property(_get_encapsulate_gre, _set_encapsulate_gre)
  segment_lists = __builtin__.property(_get_segment_lists, _set_segment_lists)


  _pyangbind_elements = OrderedDict([('config', config), ('state', state), ('encapsulate_gre', encapsulate_gre), ('segment_lists', segment_lists), ])


