# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import mappings
class ssm(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/igmp/global/ssm. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Source specific multicast (SSM).
  """
  __slots__ = ('_path_helper', '_extmethods', '__mappings',)

  _yang_name = 'ssm'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'igmp', 'global', 'ssm']

  def _get_mappings(self):
    """
    Getter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    return self.__mappings
      
  def _set_mappings(self, v, load=False):
    """
    Setter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mappings is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mappings() directly.

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mappings must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mappings = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mappings(self):
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  mappings = __builtin__.property(_get_mappings, _set_mappings)


  _pyangbind_elements = OrderedDict([('mappings', mappings), ])


from . import mappings
class ssm(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/igmp/global/ssm. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Source specific multicast (SSM).
  """
  __slots__ = ('_path_helper', '_extmethods', '__mappings',)

  _yang_name = 'ssm'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'igmp', 'global', 'ssm']

  def _get_mappings(self):
    """
    Getter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    return self.__mappings
      
  def _set_mappings(self, v, load=False):
    """
    Setter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mappings is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mappings() directly.

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mappings must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mappings = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mappings(self):
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  mappings = __builtin__.property(_get_mappings, _set_mappings)


  _pyangbind_elements = OrderedDict([('mappings', mappings), ])


from . import mappings
class ssm(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/igmp/global/ssm. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Source specific multicast (SSM).
  """
  __slots__ = ('_path_helper', '_extmethods', '__mappings',)

  _yang_name = 'ssm'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'igmp', 'global', 'ssm']

  def _get_mappings(self):
    """
    Getter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    return self.__mappings
      
  def _set_mappings(self, v, load=False):
    """
    Setter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mappings is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mappings() directly.

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mappings must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mappings = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mappings(self):
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  mappings = __builtin__.property(_get_mappings, _set_mappings)


  _pyangbind_elements = OrderedDict([('mappings', mappings), ])


from . import mappings
class ssm(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/igmp/global/ssm. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Source specific multicast (SSM).
  """
  __slots__ = ('_path_helper', '_extmethods', '__mappings',)

  _yang_name = 'ssm'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'igmp', 'global', 'ssm']

  def _get_mappings(self):
    """
    Getter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    return self.__mappings
      
  def _set_mappings(self, v, load=False):
    """
    Setter method for mappings, mapped from YANG variable /network_instances/network_instance/protocols/protocol/igmp/global/ssm/mappings (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mappings is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mappings() directly.

    YANG Description: A list of source specific multicast (SSM) mappings.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mappings must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
        })

    self.__mappings = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mappings(self):
    self.__mappings = YANGDynClass(base=mappings.mappings, is_container='container', yang_name="mappings", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)

  mappings = __builtin__.property(_get_mappings, _set_mappings)


  _pyangbind_elements = OrderedDict([('mappings', mappings), ])


