# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import reset_trigger
class reset_triggers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state for ISIS Overload Bit reset triggers
  """
  __slots__ = ('_path_helper', '_extmethods', '__reset_trigger',)

  _yang_name = 'reset-triggers'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'lsp-bit', 'overload-bit', 'reset-triggers']

  def _get_reset_trigger(self):
    """
    Getter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    return self.__reset_trigger
      
  def _set_reset_trigger(self, v, load=False):
    """
    Setter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reset_trigger is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reset_trigger() directly.

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reset_trigger must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__reset_trigger = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reset_trigger(self):
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  reset_trigger = __builtin__.property(_get_reset_trigger, _set_reset_trigger)


  _pyangbind_elements = OrderedDict([('reset_trigger', reset_trigger), ])


from . import reset_trigger
class reset_triggers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state for ISIS Overload Bit reset triggers
  """
  __slots__ = ('_path_helper', '_extmethods', '__reset_trigger',)

  _yang_name = 'reset-triggers'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'lsp-bit', 'overload-bit', 'reset-triggers']

  def _get_reset_trigger(self):
    """
    Getter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    return self.__reset_trigger
      
  def _set_reset_trigger(self, v, load=False):
    """
    Setter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reset_trigger is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reset_trigger() directly.

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reset_trigger must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__reset_trigger = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reset_trigger(self):
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  reset_trigger = __builtin__.property(_get_reset_trigger, _set_reset_trigger)


  _pyangbind_elements = OrderedDict([('reset_trigger', reset_trigger), ])


from . import reset_trigger
class reset_triggers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state for ISIS Overload Bit reset triggers
  """
  __slots__ = ('_path_helper', '_extmethods', '__reset_trigger',)

  _yang_name = 'reset-triggers'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'lsp-bit', 'overload-bit', 'reset-triggers']

  def _get_reset_trigger(self):
    """
    Getter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    return self.__reset_trigger
      
  def _set_reset_trigger(self, v, load=False):
    """
    Setter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reset_trigger is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reset_trigger() directly.

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reset_trigger must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__reset_trigger = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reset_trigger(self):
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  reset_trigger = __builtin__.property(_get_reset_trigger, _set_reset_trigger)


  _pyangbind_elements = OrderedDict([('reset_trigger', reset_trigger), ])


from . import reset_trigger
class reset_triggers(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state for ISIS Overload Bit reset triggers
  """
  __slots__ = ('_path_helper', '_extmethods', '__reset_trigger',)

  _yang_name = 'reset-triggers'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'lsp-bit', 'overload-bit', 'reset-triggers']

  def _get_reset_trigger(self):
    """
    Getter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    return self.__reset_trigger
      
  def _set_reset_trigger(self, v, load=False):
    """
    Setter method for reset_trigger, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/lsp_bit/overload_bit/reset_triggers/reset_trigger (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reset_trigger is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reset_trigger() directly.

    YANG Description: This list describes ISIS Overload reset trigger reasons.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reset_trigger must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__reset_trigger = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reset_trigger(self):
    self.__reset_trigger = YANGDynClass(base=YANGListType("reset_trigger",reset_trigger.reset_trigger, yang_name="reset-trigger", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='reset-trigger', extensions=None), is_container='list', yang_name="reset-trigger", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  reset_trigger = __builtin__.property(_get_reset_trigger, _set_reset_trigger)


  _pyangbind_elements = OrderedDict([('reset_trigger', reset_trigger), ])


