# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state information for ISIS LSP Generation
timers.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lsp_max_wait_interval','__lsp_first_wait_interval','__lsp_second_wait_interval','__adaptive_timer',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'timers', 'lsp-generation', 'state']

  def _get_lsp_max_wait_interval(self):
    """
    Getter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    return self.__lsp_max_wait_interval
      
  def _set_lsp_max_wait_interval(self, v, load=False):
    """
    Setter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_max_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_max_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_max_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_max_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_max_wait_interval(self):
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_first_wait_interval(self):
    """
    Getter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    return self.__lsp_first_wait_interval
      
  def _set_lsp_first_wait_interval(self, v, load=False):
    """
    Setter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_first_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_first_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_first_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_first_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_first_wait_interval(self):
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_second_wait_interval(self):
    """
    Getter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    return self.__lsp_second_wait_interval
      
  def _set_lsp_second_wait_interval(self, v, load=False):
    """
    Setter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_second_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_second_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_second_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_second_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_second_wait_interval(self):
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_adaptive_timer(self):
    """
    Getter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    return self.__adaptive_timer
      
  def _set_adaptive_timer(self, v, load=False):
    """
    Setter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_adaptive_timer is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_adaptive_timer() directly.

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """adaptive_timer must be of a type compatible with oc-isis-types:adaptive-timer-type""",
          'defined-type': "oc-isis-types:adaptive-timer-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)""",
        })

    self.__adaptive_timer = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_adaptive_timer(self):
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

  lsp_max_wait_interval = __builtin__.property(_get_lsp_max_wait_interval)
  lsp_first_wait_interval = __builtin__.property(_get_lsp_first_wait_interval)
  lsp_second_wait_interval = __builtin__.property(_get_lsp_second_wait_interval)
  adaptive_timer = __builtin__.property(_get_adaptive_timer)


  _pyangbind_elements = OrderedDict([('lsp_max_wait_interval', lsp_max_wait_interval), ('lsp_first_wait_interval', lsp_first_wait_interval), ('lsp_second_wait_interval', lsp_second_wait_interval), ('adaptive_timer', adaptive_timer), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state information for ISIS LSP Generation
timers.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lsp_max_wait_interval','__lsp_first_wait_interval','__lsp_second_wait_interval','__adaptive_timer',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'timers', 'lsp-generation', 'state']

  def _get_lsp_max_wait_interval(self):
    """
    Getter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    return self.__lsp_max_wait_interval
      
  def _set_lsp_max_wait_interval(self, v, load=False):
    """
    Setter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_max_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_max_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_max_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_max_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_max_wait_interval(self):
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_first_wait_interval(self):
    """
    Getter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    return self.__lsp_first_wait_interval
      
  def _set_lsp_first_wait_interval(self, v, load=False):
    """
    Setter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_first_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_first_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_first_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_first_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_first_wait_interval(self):
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_second_wait_interval(self):
    """
    Getter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    return self.__lsp_second_wait_interval
      
  def _set_lsp_second_wait_interval(self, v, load=False):
    """
    Setter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_second_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_second_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_second_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_second_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_second_wait_interval(self):
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_adaptive_timer(self):
    """
    Getter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    return self.__adaptive_timer
      
  def _set_adaptive_timer(self, v, load=False):
    """
    Setter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_adaptive_timer is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_adaptive_timer() directly.

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """adaptive_timer must be of a type compatible with oc-isis-types:adaptive-timer-type""",
          'defined-type': "oc-isis-types:adaptive-timer-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)""",
        })

    self.__adaptive_timer = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_adaptive_timer(self):
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

  lsp_max_wait_interval = __builtin__.property(_get_lsp_max_wait_interval)
  lsp_first_wait_interval = __builtin__.property(_get_lsp_first_wait_interval)
  lsp_second_wait_interval = __builtin__.property(_get_lsp_second_wait_interval)
  adaptive_timer = __builtin__.property(_get_adaptive_timer)


  _pyangbind_elements = OrderedDict([('lsp_max_wait_interval', lsp_max_wait_interval), ('lsp_first_wait_interval', lsp_first_wait_interval), ('lsp_second_wait_interval', lsp_second_wait_interval), ('adaptive_timer', adaptive_timer), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state information for ISIS LSP Generation
timers.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lsp_max_wait_interval','__lsp_first_wait_interval','__lsp_second_wait_interval','__adaptive_timer',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'timers', 'lsp-generation', 'state']

  def _get_lsp_max_wait_interval(self):
    """
    Getter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    return self.__lsp_max_wait_interval
      
  def _set_lsp_max_wait_interval(self, v, load=False):
    """
    Setter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_max_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_max_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_max_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_max_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_max_wait_interval(self):
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_first_wait_interval(self):
    """
    Getter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    return self.__lsp_first_wait_interval
      
  def _set_lsp_first_wait_interval(self, v, load=False):
    """
    Setter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_first_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_first_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_first_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_first_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_first_wait_interval(self):
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_second_wait_interval(self):
    """
    Getter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    return self.__lsp_second_wait_interval
      
  def _set_lsp_second_wait_interval(self, v, load=False):
    """
    Setter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_second_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_second_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_second_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_second_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_second_wait_interval(self):
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_adaptive_timer(self):
    """
    Getter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    return self.__adaptive_timer
      
  def _set_adaptive_timer(self, v, load=False):
    """
    Setter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_adaptive_timer is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_adaptive_timer() directly.

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """adaptive_timer must be of a type compatible with oc-isis-types:adaptive-timer-type""",
          'defined-type': "oc-isis-types:adaptive-timer-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)""",
        })

    self.__adaptive_timer = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_adaptive_timer(self):
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

  lsp_max_wait_interval = __builtin__.property(_get_lsp_max_wait_interval)
  lsp_first_wait_interval = __builtin__.property(_get_lsp_first_wait_interval)
  lsp_second_wait_interval = __builtin__.property(_get_lsp_second_wait_interval)
  adaptive_timer = __builtin__.property(_get_adaptive_timer)


  _pyangbind_elements = OrderedDict([('lsp_max_wait_interval', lsp_max_wait_interval), ('lsp_first_wait_interval', lsp_first_wait_interval), ('lsp_second_wait_interval', lsp_second_wait_interval), ('adaptive_timer', adaptive_timer), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines state information for ISIS LSP Generation
timers.
  """
  __slots__ = ('_path_helper', '_extmethods', '__lsp_max_wait_interval','__lsp_first_wait_interval','__lsp_second_wait_interval','__adaptive_timer',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'global', 'timers', 'lsp-generation', 'state']

  def _get_lsp_max_wait_interval(self):
    """
    Getter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    return self.__lsp_max_wait_interval
      
  def _set_lsp_max_wait_interval(self, v, load=False):
    """
    Setter method for lsp_max_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_max_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_max_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_max_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies max interval between
two consecutive occurrences of an LSP being generated.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_max_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_max_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_max_wait_interval(self):
    self.__lsp_max_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-max-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_first_wait_interval(self):
    """
    Getter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    return self.__lsp_first_wait_interval
      
  def _set_lsp_first_wait_interval(self, v, load=False):
    """
    Setter method for lsp_first_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_first_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_first_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_first_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the first LSP generation
delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_first_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_first_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_first_wait_interval(self):
    self.__lsp_first_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-first-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_lsp_second_wait_interval(self):
    """
    Getter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    return self.__lsp_second_wait_interval
      
  def _set_lsp_second_wait_interval(self, v, load=False):
    """
    Setter method for lsp_second_wait_interval, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/lsp_second_wait_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lsp_second_wait_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lsp_second_wait_interval() directly.

    YANG Description: Time interval in milliseconds that specifies the millisecond LSP
generation delay.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lsp_second_wait_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)""",
        })

    self.__lsp_second_wait_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lsp_second_wait_interval(self):
    self.__lsp_second_wait_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="lsp-second-wait-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint64', is_config=False)


  def _get_adaptive_timer(self):
    """
    Getter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    return self.__adaptive_timer
      
  def _set_adaptive_timer(self, v, load=False):
    """
    Setter method for adaptive_timer, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/global/timers/lsp_generation/state/adaptive_timer (oc-isis-types:adaptive-timer-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_adaptive_timer is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_adaptive_timer() directly.

    YANG Description: ISIS adaptive timer types (linear, exponential).
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """adaptive_timer must be of a type compatible with oc-isis-types:adaptive-timer-type""",
          'defined-type': "oc-isis-types:adaptive-timer-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)""",
        })

    self.__adaptive_timer = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_adaptive_timer(self):
    self.__adaptive_timer = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'LINEAR': {}, 'EXPONENTIAL': {}},), is_leaf=True, yang_name="adaptive-timer", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:adaptive-timer-type', is_config=False)

  lsp_max_wait_interval = __builtin__.property(_get_lsp_max_wait_interval)
  lsp_first_wait_interval = __builtin__.property(_get_lsp_first_wait_interval)
  lsp_second_wait_interval = __builtin__.property(_get_lsp_second_wait_interval)
  adaptive_timer = __builtin__.property(_get_adaptive_timer)


  _pyangbind_elements = OrderedDict([('lsp_max_wait_interval', lsp_max_wait_interval), ('lsp_first_wait_interval', lsp_first_wait_interval), ('lsp_second_wait_interval', lsp_second_wait_interval), ('adaptive_timer', adaptive_timer), ])


