# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import topologies
class multi_topology(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines the topology supported.
  """
  __slots__ = ('_path_helper', '_extmethods', '__topologies',)

  _yang_name = 'multi-topology'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'levels', 'level', 'link-state-database', 'lsp', 'tlvs', 'tlv', 'multi-topology']

  def _get_topologies(self):
    """
    Getter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)

    YANG Description: This container describes IS topologies.
    """
    return self.__topologies
      
  def _set_topologies(self, v, load=False):
    """
    Setter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_topologies is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_topologies() directly.

    YANG Description: This container describes IS topologies.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """topologies must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__topologies = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_topologies(self):
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

  topologies = __builtin__.property(_get_topologies)


  _pyangbind_elements = OrderedDict([('topologies', topologies), ])


from . import topologies
class multi_topology(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines the topology supported.
  """
  __slots__ = ('_path_helper', '_extmethods', '__topologies',)

  _yang_name = 'multi-topology'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'levels', 'level', 'link-state-database', 'lsp', 'tlvs', 'tlv', 'multi-topology']

  def _get_topologies(self):
    """
    Getter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)

    YANG Description: This container describes IS topologies.
    """
    return self.__topologies
      
  def _set_topologies(self, v, load=False):
    """
    Setter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_topologies is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_topologies() directly.

    YANG Description: This container describes IS topologies.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """topologies must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__topologies = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_topologies(self):
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

  topologies = __builtin__.property(_get_topologies)


  _pyangbind_elements = OrderedDict([('topologies', topologies), ])


from . import topologies
class multi_topology(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines the topology supported.
  """
  __slots__ = ('_path_helper', '_extmethods', '__topologies',)

  _yang_name = 'multi-topology'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'levels', 'level', 'link-state-database', 'lsp', 'tlvs', 'tlv', 'multi-topology']

  def _get_topologies(self):
    """
    Getter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)

    YANG Description: This container describes IS topologies.
    """
    return self.__topologies
      
  def _set_topologies(self, v, load=False):
    """
    Setter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_topologies is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_topologies() directly.

    YANG Description: This container describes IS topologies.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """topologies must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__topologies = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_topologies(self):
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

  topologies = __builtin__.property(_get_topologies)


  _pyangbind_elements = OrderedDict([('topologies', topologies), ])


from . import topologies
class multi_topology(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This container defines the topology supported.
  """
  __slots__ = ('_path_helper', '_extmethods', '__topologies',)

  _yang_name = 'multi-topology'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'isis', 'levels', 'level', 'link-state-database', 'lsp', 'tlvs', 'tlv', 'multi-topology']

  def _get_topologies(self):
    """
    Getter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)

    YANG Description: This container describes IS topologies.
    """
    return self.__topologies
      
  def _set_topologies(self, v, load=False):
    """
    Setter method for topologies, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/multi_topology/topologies (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_topologies is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_topologies() directly.

    YANG Description: This container describes IS topologies.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """topologies must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)""",
        })

    self.__topologies = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_topologies(self):
    self.__topologies = YANGDynClass(base=topologies.topologies, is_container='container', yang_name="topologies", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=False)

  topologies = __builtin__.property(_get_topologies)


  _pyangbind_elements = OrderedDict([('topologies', topologies), ])


