# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import inter_area_propagation_policy
class inter_area_propagation_policies(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/ospfv3/global/inter-area-propagation-policies. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Policies defining how inter-area propagation should be performed
by the OSPF instance
  """
  __slots__ = ('_path_helper', '_extmethods', '__inter_area_propagation_policy',)

  _yang_name = 'inter-area-propagation-policies'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'ospfv3', 'global', 'inter-area-propagation-policies']

  def _get_inter_area_propagation_policy(self):
    """
    Getter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    return self.__inter_area_propagation_policy
      
  def _set_inter_area_propagation_policy(self, v, load=False):
    """
    Setter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_inter_area_propagation_policy is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_inter_area_propagation_policy() directly.

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """inter_area_propagation_policy must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__inter_area_propagation_policy = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_inter_area_propagation_policy(self):
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  inter_area_propagation_policy = __builtin__.property(_get_inter_area_propagation_policy, _set_inter_area_propagation_policy)


  _pyangbind_elements = OrderedDict([('inter_area_propagation_policy', inter_area_propagation_policy), ])


from . import inter_area_propagation_policy
class inter_area_propagation_policies(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/ospfv3/global/inter-area-propagation-policies. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Policies defining how inter-area propagation should be performed
by the OSPF instance
  """
  __slots__ = ('_path_helper', '_extmethods', '__inter_area_propagation_policy',)

  _yang_name = 'inter-area-propagation-policies'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'ospfv3', 'global', 'inter-area-propagation-policies']

  def _get_inter_area_propagation_policy(self):
    """
    Getter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    return self.__inter_area_propagation_policy
      
  def _set_inter_area_propagation_policy(self, v, load=False):
    """
    Setter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_inter_area_propagation_policy is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_inter_area_propagation_policy() directly.

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """inter_area_propagation_policy must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__inter_area_propagation_policy = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_inter_area_propagation_policy(self):
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  inter_area_propagation_policy = __builtin__.property(_get_inter_area_propagation_policy, _set_inter_area_propagation_policy)


  _pyangbind_elements = OrderedDict([('inter_area_propagation_policy', inter_area_propagation_policy), ])


from . import inter_area_propagation_policy
class inter_area_propagation_policies(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/ospfv3/global/inter-area-propagation-policies. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Policies defining how inter-area propagation should be performed
by the OSPF instance
  """
  __slots__ = ('_path_helper', '_extmethods', '__inter_area_propagation_policy',)

  _yang_name = 'inter-area-propagation-policies'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'ospfv3', 'global', 'inter-area-propagation-policies']

  def _get_inter_area_propagation_policy(self):
    """
    Getter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    return self.__inter_area_propagation_policy
      
  def _set_inter_area_propagation_policy(self, v, load=False):
    """
    Setter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_inter_area_propagation_policy is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_inter_area_propagation_policy() directly.

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """inter_area_propagation_policy must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__inter_area_propagation_policy = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_inter_area_propagation_policy(self):
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  inter_area_propagation_policy = __builtin__.property(_get_inter_area_propagation_policy, _set_inter_area_propagation_policy)


  _pyangbind_elements = OrderedDict([('inter_area_propagation_policy', inter_area_propagation_policy), ])


from . import inter_area_propagation_policy
class inter_area_propagation_policies(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/ospfv3/global/inter-area-propagation-policies. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Policies defining how inter-area propagation should be performed
by the OSPF instance
  """
  __slots__ = ('_path_helper', '_extmethods', '__inter_area_propagation_policy',)

  _yang_name = 'inter-area-propagation-policies'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'protocols', 'protocol', 'ospfv3', 'global', 'inter-area-propagation-policies']

  def _get_inter_area_propagation_policy(self):
    """
    Getter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    return self.__inter_area_propagation_policy
      
  def _set_inter_area_propagation_policy(self, v, load=False):
    """
    Setter method for inter_area_propagation_policy, mapped from YANG variable /network_instances/network_instance/protocols/protocol/ospfv3/global/inter_area_propagation_policies/inter_area_propagation_policy (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_inter_area_propagation_policy is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_inter_area_propagation_policy() directly.

    YANG Description: A list of connections between pairs of areas - routes are
propagated from the source (src) area to the destination (dst)
area according to the policy specified
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """inter_area_propagation_policy must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)""",
        })

    self.__inter_area_propagation_policy = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_inter_area_propagation_policy(self):
    self.__inter_area_propagation_policy = YANGDynClass(base=YANGListType("src_area dst_area",inter_area_propagation_policy.inter_area_propagation_policy, yang_name="inter-area-propagation-policy", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='src-area dst-area', extensions=None), is_container='list', yang_name="inter-area-propagation-policy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='list', is_config=True)

  inter_area_propagation_policy = __builtin__.property(_get_inter_area_propagation_policy, _set_inter_area_propagation_policy)


  _pyangbind_elements = OrderedDict([('inter_area_propagation_policy', inter_area_propagation_policy), ])


