# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/tables/table/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
table
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocol','__address_family',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'tables', 'table', 'config']

  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)

    YANG Description: Reference to the protocol that the table is associated with.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Reference to the protocol that the table is associated with.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)


  def _get_address_family(self):
    """
    Getter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    return self.__address_family
      
  def _set_address_family(self, v, load=False):
    """
    Setter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_address_family is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_address_family() directly.

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """address_family must be of a type compatible with identityref""",
          'defined-type': "openconfig-network-instance:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
        })

    self.__address_family = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_address_family(self):
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

  protocol = __builtin__.property(_get_protocol, _set_protocol)
  address_family = __builtin__.property(_get_address_family, _set_address_family)


  _pyangbind_elements = OrderedDict([('protocol', protocol), ('address_family', address_family), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/tables/table/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
table
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocol','__address_family',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'tables', 'table', 'config']

  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)

    YANG Description: Reference to the protocol that the table is associated with.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Reference to the protocol that the table is associated with.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)


  def _get_address_family(self):
    """
    Getter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    return self.__address_family
      
  def _set_address_family(self, v, load=False):
    """
    Setter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_address_family is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_address_family() directly.

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """address_family must be of a type compatible with identityref""",
          'defined-type': "openconfig-network-instance:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
        })

    self.__address_family = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_address_family(self):
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

  protocol = __builtin__.property(_get_protocol, _set_protocol)
  address_family = __builtin__.property(_get_address_family, _set_address_family)


  _pyangbind_elements = OrderedDict([('protocol', protocol), ('address_family', address_family), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/tables/table/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
table
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocol','__address_family',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'tables', 'table', 'config']

  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)

    YANG Description: Reference to the protocol that the table is associated with.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Reference to the protocol that the table is associated with.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)


  def _get_address_family(self):
    """
    Getter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    return self.__address_family
      
  def _set_address_family(self, v, load=False):
    """
    Setter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_address_family is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_address_family() directly.

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """address_family must be of a type compatible with identityref""",
          'defined-type': "openconfig-network-instance:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
        })

    self.__address_family = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_address_family(self):
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

  protocol = __builtin__.property(_get_protocol, _set_protocol)
  address_family = __builtin__.property(_get_address_family, _set_address_family)


  _pyangbind_elements = OrderedDict([('protocol', protocol), ('address_family', address_family), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/tables/table/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
table
  """
  __slots__ = ('_path_helper', '_extmethods', '__protocol','__address_family',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/network-instance'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['network-instances', 'network-instance', 'tables', 'table', 'config']

  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)

    YANG Description: Reference to the protocol that the table is associated with.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/tables/table/config/protocol (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Reference to the protocol that the table is associated with.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=str, is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='leafref', is_config=True)


  def _get_address_family(self):
    """
    Getter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    return self.__address_family
      
  def _set_address_family(self, v, load=False):
    """
    Setter method for address_family, mapped from YANG variable /network_instances/network_instance/tables/table/config/address_family (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_address_family is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_address_family() directly.

    YANG Description: The address family (IPv4, IPv6) of the table's entries
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """address_family must be of a type compatible with identityref""",
          'defined-type': "openconfig-network-instance:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
        })

    self.__address_family = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_address_family(self):
    self.__address_family = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'openconfig-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},), is_leaf=True, yang_name="address-family", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)

  protocol = __builtin__.property(_get_protocol, _set_protocol)
  address_family = __builtin__.property(_get_address_family, _set_address_family)


  _pyangbind_elements = OrderedDict([('protocol', protocol), ('address_family', address_family), ])


