# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import mep_endpoint
class mep_endpoints(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-oam - based on the path /oam/cfm/domains/maintenance-domain/maintenance-associations/maintenance-association/mep-endpoints. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for full mesh MEPs under the maintenance association.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mep_endpoint',)

  _yang_name = 'mep-endpoints'
  _yang_namespace = 'http://openconfig.net/yang/oam'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mep_endpoint = YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['oam', 'cfm', 'domains', 'maintenance-domain', 'maintenance-associations', 'maintenance-association', 'mep-endpoints']

  def _get_mep_endpoint(self):
    """
    Getter method for mep_endpoint, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint (list)

    YANG Description: collection of full mesh MEPs under the maintenance association.
    """
    return self.__mep_endpoint
      
  def _set_mep_endpoint(self, v, load=False):
    """
    Setter method for mep_endpoint, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mep_endpoint is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mep_endpoint() directly.

    YANG Description: collection of full mesh MEPs under the maintenance association.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mep_endpoint must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)""",
        })

    self.__mep_endpoint = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mep_endpoint(self):
    self.__mep_endpoint = YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)

  mep_endpoint = __builtin__.property(_get_mep_endpoint, _set_mep_endpoint)


  _pyangbind_elements = OrderedDict([('mep_endpoint', mep_endpoint), ])


from . import mep_endpoint
class mep_endpoints(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-oam - based on the path /oam/cfm/domains/maintenance-domain/maintenance-associations/maintenance-association/mep-endpoints. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Container for full mesh MEPs under the maintenance association.
  """
  __slots__ = ('_path_helper', '_extmethods', '__mep_endpoint',)

  _yang_name = 'mep-endpoints'
  _yang_namespace = 'http://openconfig.net/yang/oam'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__mep_endpoint = YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['oam', 'cfm', 'domains', 'maintenance-domain', 'maintenance-associations', 'maintenance-association', 'mep-endpoints']

  def _get_mep_endpoint(self):
    """
    Getter method for mep_endpoint, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint (list)

    YANG Description: collection of full mesh MEPs under the maintenance association.
    """
    return self.__mep_endpoint
      
  def _set_mep_endpoint(self, v, load=False):
    """
    Setter method for mep_endpoint, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mep_endpoint is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mep_endpoint() directly.

    YANG Description: collection of full mesh MEPs under the maintenance association.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mep_endpoint must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)""",
        })

    self.__mep_endpoint = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mep_endpoint(self):
    self.__mep_endpoint = YANGDynClass(base=YANGListType("local_mep_id",mep_endpoint.mep_endpoint, yang_name="mep-endpoint", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='local-mep-id', extensions=None), is_container='list', yang_name="mep-endpoint", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='list', is_config=True)

  mep_endpoint = __builtin__.property(_get_mep_endpoint, _set_mep_endpoint)


  _pyangbind_elements = OrderedDict([('mep_endpoint', mep_endpoint), ])


