# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-oam - based on the path /oam/cfm/domains/maintenance-domain/maintenance-associations/maintenance-association/mep-endpoints/mep-endpoint/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration data for a MEP.
  """
  __slots__ = ('_path_helper', '_extmethods', '__ccm_enabled','__lowest_priority_defect','__fng_alarm_time','__fng_reset_time','__local_mep_id','__interface','__include_mep_port_status_in_tlv','__include_mep_interface_status_in_tlv','__direction','__auto_discovery',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/oam'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ccm_enabled = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__lowest_priority_defect = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)
    self.__fng_alarm_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    self.__fng_reset_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    self.__local_mep_id = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)
    self.__interface = YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)
    self.__include_mep_port_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__include_mep_interface_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__direction = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)
    self.__auto_discovery = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['oam', 'cfm', 'domains', 'maintenance-domain', 'maintenance-associations', 'maintenance-association', 'mep-endpoints', 'mep-endpoint', 'config']

  def _get_ccm_enabled(self):
    """
    Getter method for ccm_enabled, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/ccm_enabled (boolean)

    YANG Description: Indicates whether the MEP can generate CCMs. If TRUE, the
MEP will generate CCM PDUs.
    """
    return self.__ccm_enabled
      
  def _set_ccm_enabled(self, v, load=False):
    """
    Setter method for ccm_enabled, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/ccm_enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ccm_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ccm_enabled() directly.

    YANG Description: Indicates whether the MEP can generate CCMs. If TRUE, the
MEP will generate CCM PDUs.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ccm_enabled must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__ccm_enabled = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ccm_enabled(self):
    self.__ccm_enabled = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_lowest_priority_defect(self):
    """
    Getter method for lowest_priority_defect, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/lowest_priority_defect (oc-cfm-types:lowest-alarm-priority-type)

    YANG Description: The lowest priority defect that is allowed to generate
fault alarms.
    """
    return self.__lowest_priority_defect
      
  def _set_lowest_priority_defect(self, v, load=False):
    """
    Setter method for lowest_priority_defect, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/lowest_priority_defect (oc-cfm-types:lowest-alarm-priority-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lowest_priority_defect is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lowest_priority_defect() directly.

    YANG Description: The lowest priority defect that is allowed to generate
fault alarms.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lowest_priority_defect must be of a type compatible with oc-cfm-types:lowest-alarm-priority-type""",
          'defined-type': "oc-cfm-types:lowest-alarm-priority-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)""",
        })

    self.__lowest_priority_defect = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lowest_priority_defect(self):
    self.__lowest_priority_defect = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)


  def _get_fng_alarm_time(self):
    """
    Getter method for fng_alarm_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_alarm_time (uint16)

    YANG Description: The time that defect must be present before a Fault Alarm
is issued.
    """
    return self.__fng_alarm_time
      
  def _set_fng_alarm_time(self, v, load=False):
    """
    Setter method for fng_alarm_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_alarm_time (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fng_alarm_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fng_alarm_time() directly.

    YANG Description: The time that defect must be present before a Fault Alarm
is issued.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fng_alarm_time must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)""",
        })

    self.__fng_alarm_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fng_alarm_time(self):
    self.__fng_alarm_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)


  def _get_fng_reset_time(self):
    """
    Getter method for fng_reset_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_reset_time (uint16)

    YANG Description: The time that defects must be absent before resetting a
Fault Alarm.
    """
    return self.__fng_reset_time
      
  def _set_fng_reset_time(self, v, load=False):
    """
    Setter method for fng_reset_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_reset_time (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fng_reset_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fng_reset_time() directly.

    YANG Description: The time that defects must be absent before resetting a
Fault Alarm.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fng_reset_time must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)""",
        })

    self.__fng_reset_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fng_reset_time(self):
    self.__fng_reset_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)


  def _get_local_mep_id(self):
    """
    Getter method for local_mep_id, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/local_mep_id (oc-cfm-types:mep-id-type)

    YANG Description: The identifier of a Local MEP.  Unique per given  MA 
    """
    return self.__local_mep_id
      
  def _set_local_mep_id(self, v, load=False):
    """
    Setter method for local_mep_id, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/local_mep_id (oc-cfm-types:mep-id-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_local_mep_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_local_mep_id() directly.

    YANG Description: The identifier of a Local MEP.  Unique per given  MA 
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """local_mep_id must be of a type compatible with oc-cfm-types:mep-id-type""",
          'defined-type': "oc-cfm-types:mep-id-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)""",
        })

    self.__local_mep_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_local_mep_id(self):
    self.__local_mep_id = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)


  def _get_interface(self):
    """
    Getter method for interface, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/interface (leafref)

    YANG Description: Interface directly associated with the MEP id.
    """
    return self.__interface
      
  def _set_interface(self, v, load=False):
    """
    Setter method for interface, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/interface (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_interface is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_interface() directly.

    YANG Description: Interface directly associated with the MEP id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """interface must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)""",
        })

    self.__interface = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_interface(self):
    self.__interface = YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)


  def _get_include_mep_port_status_in_tlv(self):
    """
    Getter method for include_mep_port_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_port_status_in_tlv (boolean)

    YANG Description: Indicates whether a Port Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Port Status
TLV is to be included. A value of 'false' indicates that the
Port Status TLV is not to be included.
    """
    return self.__include_mep_port_status_in_tlv
      
  def _set_include_mep_port_status_in_tlv(self, v, load=False):
    """
    Setter method for include_mep_port_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_port_status_in_tlv (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_include_mep_port_status_in_tlv is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_include_mep_port_status_in_tlv() directly.

    YANG Description: Indicates whether a Port Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Port Status
TLV is to be included. A value of 'false' indicates that the
Port Status TLV is not to be included.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """include_mep_port_status_in_tlv must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__include_mep_port_status_in_tlv = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_include_mep_port_status_in_tlv(self):
    self.__include_mep_port_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_include_mep_interface_status_in_tlv(self):
    """
    Getter method for include_mep_interface_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_interface_status_in_tlv (boolean)

    YANG Description: Indicates whether a Interface Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Interface Status TLV
is to be included. A value of 'false' indicates that the Interface
Status TLV is not to be included.
    """
    return self.__include_mep_interface_status_in_tlv
      
  def _set_include_mep_interface_status_in_tlv(self, v, load=False):
    """
    Setter method for include_mep_interface_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_interface_status_in_tlv (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_include_mep_interface_status_in_tlv is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_include_mep_interface_status_in_tlv() directly.

    YANG Description: Indicates whether a Interface Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Interface Status TLV
is to be included. A value of 'false' indicates that the Interface
Status TLV is not to be included.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """include_mep_interface_status_in_tlv must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__include_mep_interface_status_in_tlv = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_include_mep_interface_status_in_tlv(self):
    self.__include_mep_interface_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_direction(self):
    """
    Getter method for direction, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/direction (enumeration)

    YANG Description: The direction in which the MEP faces on the Bridge/Xconnect
Port. Example, up or down.
    """
    return self.__direction
      
  def _set_direction(self, v, load=False):
    """
    Setter method for direction, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/direction (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_direction is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_direction() directly.

    YANG Description: The direction in which the MEP faces on the Bridge/Xconnect
Port. Example, up or down.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """direction must be of a type compatible with enumeration""",
          'defined-type': "openconfig-oam-cfm:enumeration",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)""",
        })

    self.__direction = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_direction(self):
    self.__direction = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)


  def _get_auto_discovery(self):
    """
    Getter method for auto_discovery, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/auto_discovery (boolean)

    YANG Description: A boolean value to enable or disable auto-discovery.
users must configure explicitly true or false.
If unset, then it’s implementation specific.
    """
    return self.__auto_discovery
      
  def _set_auto_discovery(self, v, load=False):
    """
    Setter method for auto_discovery, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/auto_discovery (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_auto_discovery is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_auto_discovery() directly.

    YANG Description: A boolean value to enable or disable auto-discovery.
users must configure explicitly true or false.
If unset, then it’s implementation specific.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """auto_discovery must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__auto_discovery = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_auto_discovery(self):
    self.__auto_discovery = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)

  ccm_enabled = __builtin__.property(_get_ccm_enabled, _set_ccm_enabled)
  lowest_priority_defect = __builtin__.property(_get_lowest_priority_defect, _set_lowest_priority_defect)
  fng_alarm_time = __builtin__.property(_get_fng_alarm_time, _set_fng_alarm_time)
  fng_reset_time = __builtin__.property(_get_fng_reset_time, _set_fng_reset_time)
  local_mep_id = __builtin__.property(_get_local_mep_id, _set_local_mep_id)
  interface = __builtin__.property(_get_interface, _set_interface)
  include_mep_port_status_in_tlv = __builtin__.property(_get_include_mep_port_status_in_tlv, _set_include_mep_port_status_in_tlv)
  include_mep_interface_status_in_tlv = __builtin__.property(_get_include_mep_interface_status_in_tlv, _set_include_mep_interface_status_in_tlv)
  direction = __builtin__.property(_get_direction, _set_direction)
  auto_discovery = __builtin__.property(_get_auto_discovery, _set_auto_discovery)


  _pyangbind_elements = OrderedDict([('ccm_enabled', ccm_enabled), ('lowest_priority_defect', lowest_priority_defect), ('fng_alarm_time', fng_alarm_time), ('fng_reset_time', fng_reset_time), ('local_mep_id', local_mep_id), ('interface', interface), ('include_mep_port_status_in_tlv', include_mep_port_status_in_tlv), ('include_mep_interface_status_in_tlv', include_mep_interface_status_in_tlv), ('direction', direction), ('auto_discovery', auto_discovery), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-oam - based on the path /oam/cfm/domains/maintenance-domain/maintenance-associations/maintenance-association/mep-endpoints/mep-endpoint/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration data for a MEP.
  """
  __slots__ = ('_path_helper', '_extmethods', '__ccm_enabled','__lowest_priority_defect','__fng_alarm_time','__fng_reset_time','__local_mep_id','__interface','__include_mep_port_status_in_tlv','__include_mep_interface_status_in_tlv','__direction','__auto_discovery',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/oam'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ccm_enabled = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__lowest_priority_defect = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)
    self.__fng_alarm_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    self.__fng_reset_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    self.__local_mep_id = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)
    self.__interface = YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)
    self.__include_mep_port_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__include_mep_interface_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    self.__direction = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)
    self.__auto_discovery = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['oam', 'cfm', 'domains', 'maintenance-domain', 'maintenance-associations', 'maintenance-association', 'mep-endpoints', 'mep-endpoint', 'config']

  def _get_ccm_enabled(self):
    """
    Getter method for ccm_enabled, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/ccm_enabled (boolean)

    YANG Description: Indicates whether the MEP can generate CCMs. If TRUE, the
MEP will generate CCM PDUs.
    """
    return self.__ccm_enabled
      
  def _set_ccm_enabled(self, v, load=False):
    """
    Setter method for ccm_enabled, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/ccm_enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ccm_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ccm_enabled() directly.

    YANG Description: Indicates whether the MEP can generate CCMs. If TRUE, the
MEP will generate CCM PDUs.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ccm_enabled must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__ccm_enabled = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ccm_enabled(self):
    self.__ccm_enabled = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="ccm-enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_lowest_priority_defect(self):
    """
    Getter method for lowest_priority_defect, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/lowest_priority_defect (oc-cfm-types:lowest-alarm-priority-type)

    YANG Description: The lowest priority defect that is allowed to generate
fault alarms.
    """
    return self.__lowest_priority_defect
      
  def _set_lowest_priority_defect(self, v, load=False):
    """
    Setter method for lowest_priority_defect, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/lowest_priority_defect (oc-cfm-types:lowest-alarm-priority-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lowest_priority_defect is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lowest_priority_defect() directly.

    YANG Description: The lowest priority defect that is allowed to generate
fault alarms.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lowest_priority_defect must be of a type compatible with oc-cfm-types:lowest-alarm-priority-type""",
          'defined-type': "oc-cfm-types:lowest-alarm-priority-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)""",
        })

    self.__lowest_priority_defect = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lowest_priority_defect(self):
    self.__lowest_priority_defect = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'ALL_DEF': {'value': 1}, 'MAC_REMOTE_ERROR_XCON': {'value': 2}, 'REMOTE_ERROR_XCON': {'value': 3}, 'ERROR_XCON': {'value': 4}, 'XCON': {'value': 5}, 'NO_XCON': {'value': 6}},), default=str("MAC_REMOTE_ERROR_XCON"), is_leaf=True, yang_name="lowest-priority-defect", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:lowest-alarm-priority-type', is_config=True)


  def _get_fng_alarm_time(self):
    """
    Getter method for fng_alarm_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_alarm_time (uint16)

    YANG Description: The time that defect must be present before a Fault Alarm
is issued.
    """
    return self.__fng_alarm_time
      
  def _set_fng_alarm_time(self, v, load=False):
    """
    Setter method for fng_alarm_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_alarm_time (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fng_alarm_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fng_alarm_time() directly.

    YANG Description: The time that defect must be present before a Fault Alarm
is issued.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fng_alarm_time must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)""",
        })

    self.__fng_alarm_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fng_alarm_time(self):
    self.__fng_alarm_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(2500), is_leaf=True, yang_name="fng-alarm-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)


  def _get_fng_reset_time(self):
    """
    Getter method for fng_reset_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_reset_time (uint16)

    YANG Description: The time that defects must be absent before resetting a
Fault Alarm.
    """
    return self.__fng_reset_time
      
  def _set_fng_reset_time(self, v, load=False):
    """
    Setter method for fng_reset_time, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/fng_reset_time (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fng_reset_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fng_reset_time() directly.

    YANG Description: The time that defects must be absent before resetting a
Fault Alarm.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fng_reset_time must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)""",
        })

    self.__fng_reset_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fng_reset_time(self):
    self.__fng_reset_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['2500..10000']}), default=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16)(10000), is_leaf=True, yang_name="fng-reset-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='uint16', is_config=True)


  def _get_local_mep_id(self):
    """
    Getter method for local_mep_id, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/local_mep_id (oc-cfm-types:mep-id-type)

    YANG Description: The identifier of a Local MEP.  Unique per given  MA 
    """
    return self.__local_mep_id
      
  def _set_local_mep_id(self, v, load=False):
    """
    Setter method for local_mep_id, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/local_mep_id (oc-cfm-types:mep-id-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_local_mep_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_local_mep_id() directly.

    YANG Description: The identifier of a Local MEP.  Unique per given  MA 
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """local_mep_id must be of a type compatible with oc-cfm-types:mep-id-type""",
          'defined-type': "oc-cfm-types:mep-id-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)""",
        })

    self.__local_mep_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_local_mep_id(self):
    self.__local_mep_id = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={'range': ['1..8191']}), is_leaf=True, yang_name="local-mep-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='oc-cfm-types:mep-id-type', is_config=True)


  def _get_interface(self):
    """
    Getter method for interface, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/interface (leafref)

    YANG Description: Interface directly associated with the MEP id.
    """
    return self.__interface
      
  def _set_interface(self, v, load=False):
    """
    Setter method for interface, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/interface (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_interface is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_interface() directly.

    YANG Description: Interface directly associated with the MEP id.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """interface must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)""",
        })

    self.__interface = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_interface(self):
    self.__interface = YANGDynClass(base=str, is_leaf=True, yang_name="interface", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='leafref', is_config=True)


  def _get_include_mep_port_status_in_tlv(self):
    """
    Getter method for include_mep_port_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_port_status_in_tlv (boolean)

    YANG Description: Indicates whether a Port Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Port Status
TLV is to be included. A value of 'false' indicates that the
Port Status TLV is not to be included.
    """
    return self.__include_mep_port_status_in_tlv
      
  def _set_include_mep_port_status_in_tlv(self, v, load=False):
    """
    Setter method for include_mep_port_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_port_status_in_tlv (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_include_mep_port_status_in_tlv is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_include_mep_port_status_in_tlv() directly.

    YANG Description: Indicates whether a Port Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Port Status
TLV is to be included. A value of 'false' indicates that the
Port Status TLV is not to be included.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """include_mep_port_status_in_tlv must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__include_mep_port_status_in_tlv = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_include_mep_port_status_in_tlv(self):
    self.__include_mep_port_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-port-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_include_mep_interface_status_in_tlv(self):
    """
    Getter method for include_mep_interface_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_interface_status_in_tlv (boolean)

    YANG Description: Indicates whether a Interface Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Interface Status TLV
is to be included. A value of 'false' indicates that the Interface
Status TLV is not to be included.
    """
    return self.__include_mep_interface_status_in_tlv
      
  def _set_include_mep_interface_status_in_tlv(self, v, load=False):
    """
    Setter method for include_mep_interface_status_in_tlv, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/include_mep_interface_status_in_tlv (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_include_mep_interface_status_in_tlv is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_include_mep_interface_status_in_tlv() directly.

    YANG Description: Indicates whether a Interface Status TLV is included in CCM frame
transmission. A value of 'true' indicates that the Interface Status TLV
is to be included. A value of 'false' indicates that the Interface
Status TLV is not to be included.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """include_mep_interface_status_in_tlv must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__include_mep_interface_status_in_tlv = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_include_mep_interface_status_in_tlv(self):
    self.__include_mep_interface_status_in_tlv = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="include-mep-interface-status-in-tlv", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)


  def _get_direction(self):
    """
    Getter method for direction, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/direction (enumeration)

    YANG Description: The direction in which the MEP faces on the Bridge/Xconnect
Port. Example, up or down.
    """
    return self.__direction
      
  def _set_direction(self, v, load=False):
    """
    Setter method for direction, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/direction (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_direction is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_direction() directly.

    YANG Description: The direction in which the MEP faces on the Bridge/Xconnect
Port. Example, up or down.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """direction must be of a type compatible with enumeration""",
          'defined-type': "openconfig-oam-cfm:enumeration",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)""",
        })

    self.__direction = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_direction(self):
    self.__direction = YANGDynClass(base=RestrictedClassType(base_type=str,                                     restriction_type="dict_key",                                     restriction_arg={'DOWN': {'value': 1}, 'UP': {'value': 2}},), is_leaf=True, yang_name="direction", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='enumeration', is_config=True)


  def _get_auto_discovery(self):
    """
    Getter method for auto_discovery, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/auto_discovery (boolean)

    YANG Description: A boolean value to enable or disable auto-discovery.
users must configure explicitly true or false.
If unset, then it’s implementation specific.
    """
    return self.__auto_discovery
      
  def _set_auto_discovery(self, v, load=False):
    """
    Setter method for auto_discovery, mapped from YANG variable /oam/cfm/domains/maintenance_domain/maintenance_associations/maintenance_association/mep_endpoints/mep_endpoint/config/auto_discovery (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_auto_discovery is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_auto_discovery() directly.

    YANG Description: A boolean value to enable or disable auto-discovery.
users must configure explicitly true or false.
If unset, then it’s implementation specific.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """auto_discovery must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)""",
        })

    self.__auto_discovery = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_auto_discovery(self):
    self.__auto_discovery = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-discovery", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/oam/cfm', defining_module='openconfig-oam-cfm', yang_type='boolean', is_config=True)

  ccm_enabled = __builtin__.property(_get_ccm_enabled, _set_ccm_enabled)
  lowest_priority_defect = __builtin__.property(_get_lowest_priority_defect, _set_lowest_priority_defect)
  fng_alarm_time = __builtin__.property(_get_fng_alarm_time, _set_fng_alarm_time)
  fng_reset_time = __builtin__.property(_get_fng_reset_time, _set_fng_reset_time)
  local_mep_id = __builtin__.property(_get_local_mep_id, _set_local_mep_id)
  interface = __builtin__.property(_get_interface, _set_interface)
  include_mep_port_status_in_tlv = __builtin__.property(_get_include_mep_port_status_in_tlv, _set_include_mep_port_status_in_tlv)
  include_mep_interface_status_in_tlv = __builtin__.property(_get_include_mep_interface_status_in_tlv, _set_include_mep_interface_status_in_tlv)
  direction = __builtin__.property(_get_direction, _set_direction)
  auto_discovery = __builtin__.property(_get_auto_discovery, _set_auto_discovery)


  _pyangbind_elements = OrderedDict([('ccm_enabled', ccm_enabled), ('lowest_priority_defect', lowest_priority_defect), ('fng_alarm_time', fng_alarm_time), ('fng_reset_time', fng_reset_time), ('local_mep_id', local_mep_id), ('interface', interface), ('include_mep_port_status_in_tlv', include_mep_port_status_in_tlv), ('include_mep_interface_status_in_tlv', include_mep_interface_status_in_tlv), ('direction', direction), ('auto_discovery', auto_discovery), ])


