# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import state
class penalty(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /operational-mode-descriptors/operational-modes/mode-descriptors/mode-descriptor/penalties/penalty. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Penalties includes contributions from different impairments including
cd, pmd, low RX Power, pdl,...
- For parameter values below lowest up-to-boundary value, the penalty is 0.
- For parameter values between lowest and highest up-to-boundary
values, penalty could be linearly interpolated.
- For parameter values above highest up-to-boundary value, the penalty is the one
included within penalty-value attribute associated to the highest up-to-boundary
  """
  __slots__ = ('_path_helper', '_extmethods', '__parameter_and_unit','__up_to_boundary','__state',)

  _yang_name = 'penalty'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__parameter_and_unit = YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    self.__up_to_boundary = YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['operational-mode-descriptors', 'operational-modes', 'mode-descriptors', 'mode-descriptor', 'penalties', 'penalty']

  def _get_parameter_and_unit(self):
    """
    Getter method for parameter_and_unit, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/parameter_and_unit (leafref)

    YANG Description: Impairment and unit leading to the penalty (i.e., cd-ps)
    """
    return self.__parameter_and_unit
      
  def _set_parameter_and_unit(self, v, load=False):
    """
    Setter method for parameter_and_unit, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/parameter_and_unit (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_parameter_and_unit is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_parameter_and_unit() directly.

    YANG Description: Impairment and unit leading to the penalty (i.e., cd-ps)
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """parameter_and_unit must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)""",
        })

    self.__parameter_and_unit = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_parameter_and_unit(self):
    self.__parameter_and_unit = YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)


  def _get_up_to_boundary(self):
    """
    Getter method for up_to_boundary, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/up_to_boundary (leafref)

    YANG Description: defines the upper (for positive values) and lower (for negative values)
limit for which the penalty value is valid.
    """
    return self.__up_to_boundary
      
  def _set_up_to_boundary(self, v, load=False):
    """
    Setter method for up_to_boundary, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/up_to_boundary (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_up_to_boundary is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_up_to_boundary() directly.

    YANG Description: defines the upper (for positive values) and lower (for negative values)
limit for which the penalty value is valid.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """up_to_boundary must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)""",
        })

    self.__up_to_boundary = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_up_to_boundary(self):
    self.__up_to_boundary = YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/state (container)

    YANG Description: Penalties list element's state attributes top container.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Penalties list element's state attributes top container.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)

  parameter_and_unit = __builtin__.property(_get_parameter_and_unit)
  up_to_boundary = __builtin__.property(_get_up_to_boundary)
  state = __builtin__.property(_get_state)


  _pyangbind_elements = OrderedDict([('parameter_and_unit', parameter_and_unit), ('up_to_boundary', up_to_boundary), ('state', state), ])


from . import state
class penalty(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-terminal-device-properties - based on the path /operational-mode-descriptors/operational-modes/mode-descriptors/mode-descriptor/penalties/penalty. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Penalties includes contributions from different impairments including
cd, pmd, low RX Power, pdl,...
- For parameter values below lowest up-to-boundary value, the penalty is 0.
- For parameter values between lowest and highest up-to-boundary
values, penalty could be linearly interpolated.
- For parameter values above highest up-to-boundary value, the penalty is the one
included within penalty-value attribute associated to the highest up-to-boundary
  """
  __slots__ = ('_path_helper', '_extmethods', '__parameter_and_unit','__up_to_boundary','__state',)

  _yang_name = 'penalty'
  _yang_namespace = 'http://openconfig.net/yang/openconfig-terminal-device-properties'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__parameter_and_unit = YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    self.__up_to_boundary = YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['operational-mode-descriptors', 'operational-modes', 'mode-descriptors', 'mode-descriptor', 'penalties', 'penalty']

  def _get_parameter_and_unit(self):
    """
    Getter method for parameter_and_unit, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/parameter_and_unit (leafref)

    YANG Description: Impairment and unit leading to the penalty (i.e., cd-ps)
    """
    return self.__parameter_and_unit
      
  def _set_parameter_and_unit(self, v, load=False):
    """
    Setter method for parameter_and_unit, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/parameter_and_unit (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_parameter_and_unit is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_parameter_and_unit() directly.

    YANG Description: Impairment and unit leading to the penalty (i.e., cd-ps)
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """parameter_and_unit must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)""",
        })

    self.__parameter_and_unit = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_parameter_and_unit(self):
    self.__parameter_and_unit = YANGDynClass(base=str, is_leaf=True, yang_name="parameter-and-unit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)


  def _get_up_to_boundary(self):
    """
    Getter method for up_to_boundary, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/up_to_boundary (leafref)

    YANG Description: defines the upper (for positive values) and lower (for negative values)
limit for which the penalty value is valid.
    """
    return self.__up_to_boundary
      
  def _set_up_to_boundary(self, v, load=False):
    """
    Setter method for up_to_boundary, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/up_to_boundary (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_up_to_boundary is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_up_to_boundary() directly.

    YANG Description: defines the upper (for positive values) and lower (for negative values)
limit for which the penalty value is valid.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """up_to_boundary must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)""",
        })

    self.__up_to_boundary = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_up_to_boundary(self):
    self.__up_to_boundary = YANGDynClass(base=str, is_leaf=True, yang_name="up-to-boundary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='leafref', is_config=False)


  def _get_state(self):
    """
    Getter method for state, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/state (container)

    YANG Description: Penalties list element's state attributes top container.
    """
    return self.__state
      
  def _set_state(self, v, load=False):
    """
    Setter method for state, mapped from YANG variable /operational_mode_descriptors/operational_modes/mode_descriptors/mode_descriptor/penalties/penalty/state (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_state is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_state() directly.

    YANG Description: Penalties list element's state attributes top container.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """state must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)""",
        })

    self.__state = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_state(self):
    self.__state = YANGDynClass(base=state.state, is_container='container', yang_name="state", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/openconfig-terminal-device-properties', defining_module='openconfig-terminal-device-properties', yang_type='container', is_config=False)

  parameter_and_unit = __builtin__.property(_get_parameter_and_unit)
  up_to_boundary = __builtin__.property(_get_up_to_boundary)
  state = __builtin__.property(_get_state)


  _pyangbind_elements = OrderedDict([('parameter_and_unit', parameter_and_unit), ('up_to_boundary', up_to_boundary), ('state', state), ])


