# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import attenuators
class optical_attenuator(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-optical-attenuator - based on the path /optical-attenuator. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for attenuators
  """
  __slots__ = ('_path_helper', '_extmethods', '__attenuators',)

  _yang_name = 'optical-attenuator'
  _yang_namespace = 'http://openconfig.net/yang/optical-attenuator'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__attenuators = YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['optical-attenuator']

  def _get_attenuators(self):
    """
    Getter method for attenuators, mapped from YANG variable /optical_attenuator/attenuators (container)

    YANG Description: Enclosing container for list of attenuators
    """
    return self.__attenuators
      
  def _set_attenuators(self, v, load=False):
    """
    Setter method for attenuators, mapped from YANG variable /optical_attenuator/attenuators (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_attenuators is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_attenuators() directly.

    YANG Description: Enclosing container for list of attenuators
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """attenuators must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)""",
        })

    self.__attenuators = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_attenuators(self):
    self.__attenuators = YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)

  attenuators = __builtin__.property(_get_attenuators, _set_attenuators)


  _pyangbind_elements = OrderedDict([('attenuators', attenuators), ])


from . import attenuators
class optical_attenuator(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-optical-attenuator - based on the path /optical-attenuator. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for attenuators
  """
  __slots__ = ('_path_helper', '_extmethods', '__attenuators',)

  _yang_name = 'optical-attenuator'
  _yang_namespace = 'http://openconfig.net/yang/optical-attenuator'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__attenuators = YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['optical-attenuator']

  def _get_attenuators(self):
    """
    Getter method for attenuators, mapped from YANG variable /optical_attenuator/attenuators (container)

    YANG Description: Enclosing container for list of attenuators
    """
    return self.__attenuators
      
  def _set_attenuators(self, v, load=False):
    """
    Setter method for attenuators, mapped from YANG variable /optical_attenuator/attenuators (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_attenuators is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_attenuators() directly.

    YANG Description: Enclosing container for list of attenuators
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """attenuators must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)""",
        })

    self.__attenuators = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_attenuators(self):
    self.__attenuators = YANGDynClass(base=attenuators.attenuators, is_container='container', yang_name="attenuators", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/optical-attenuator', defining_module='openconfig-optical-attenuator', yang_type='container', is_config=True)

  attenuators = __builtin__.property(_get_attenuators, _set_attenuators)


  _pyangbind_elements = OrderedDict([('attenuators', attenuators), ])


