# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import items
class history(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-probes - based on the path /probes/probe/tests/test/results/history. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Historical data of the tests.
  """
  __slots__ = ('_path_helper', '_extmethods', '__items',)

  _yang_name = 'history'
  _yang_namespace = 'http://openconfig.net/yang/probes'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__items = YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['probes', 'probe', 'tests', 'test', 'results', 'history']

  def _get_items(self):
    """
    Getter method for items, mapped from YANG variable /probes/probe/tests/test/results/history/items (container)

    YANG Description: The list of items in the probe history.
The length depends on the history size.
    """
    return self.__items
      
  def _set_items(self, v, load=False):
    """
    Setter method for items, mapped from YANG variable /probes/probe/tests/test/results/history/items (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_items is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_items() directly.

    YANG Description: The list of items in the probe history.
The length depends on the history size.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """items must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)""",
        })

    self.__items = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_items(self):
    self.__items = YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)

  items = __builtin__.property(_get_items)


  _pyangbind_elements = OrderedDict([('items', items), ])


from . import items
class history(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-probes - based on the path /probes/probe/tests/test/results/history. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Historical data of the tests.
  """
  __slots__ = ('_path_helper', '_extmethods', '__items',)

  _yang_name = 'history'
  _yang_namespace = 'http://openconfig.net/yang/probes'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__items = YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['probes', 'probe', 'tests', 'test', 'results', 'history']

  def _get_items(self):
    """
    Getter method for items, mapped from YANG variable /probes/probe/tests/test/results/history/items (container)

    YANG Description: The list of items in the probe history.
The length depends on the history size.
    """
    return self.__items
      
  def _set_items(self, v, load=False):
    """
    Setter method for items, mapped from YANG variable /probes/probe/tests/test/results/history/items (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_items is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_items() directly.

    YANG Description: The list of items in the probe history.
The length depends on the history size.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """items must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)""",
        })

    self.__items = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_items(self):
    self.__items = YANGDynClass(base=items.items, is_container='container', yang_name="items", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/probes', defining_module='openconfig-probes', yang_type='container', is_config=False)

  items = __builtin__.property(_get_items)


  _pyangbind_elements = OrderedDict([('items', items), ])


