# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


from . import queue_management_profile
class queue_management_profiles(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Surrounding container for the list of configured
queue management profiles.
  """
  __slots__ = ('_path_helper', '_extmethods', '__queue_management_profile',)

  _yang_name = 'queue-management-profiles'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles']

  def _get_queue_management_profile(self):
    """
    Getter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    return self.__queue_management_profile
      
  def _set_queue_management_profile(self, v, load=False):
    """
    Setter method for queue_management_profile, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_queue_management_profile is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_queue_management_profile() directly.

    YANG Description: A queue management profile within the OpenConfig QoS model
specifies how packets are ECN marked/dropped for a particular
instance of a queue on a particular interface. for example,
whether RED, or WRED is applied to manage the queue's occupancy.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """queue_management_profile must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)""",
        })

    self.__queue_management_profile = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_queue_management_profile(self):
    self.__queue_management_profile = YANGDynClass(base=YANGListType("name",queue_management_profile.queue_management_profile, yang_name="queue-management-profile", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="queue-management-profile", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='list', is_config=True)

  queue_management_profile = __builtin__.property(_get_queue_management_profile, _set_queue_management_profile)


  _pyangbind_elements = OrderedDict([('queue_management_profile', queue_management_profile), ])


