# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles/queue-management-profile/red/uniform/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the RED.
  """
  __slots__ = ('_path_helper', '_extmethods', '__min_threshold','__max_threshold','__min_threshold_percent','__max_threshold_percent','__enable_ecn','__drop',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'red', 'uniform', 'config']

  def _get_min_threshold(self):
    """
    Getter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    return self.__min_threshold
      
  def _set_min_threshold(self, v, load=False):
    """
    Setter method for min_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in bytes.
When the average queue length is less than minth, all packets are admitted
to the queue.  Mututally exclusive with min-threshold-percent and
max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold(self):
    self.__min_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold(self):
    """
    Getter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    return self.__max_threshold
      
  def _set_max_threshold(self, v, load=False):
    """
    Setter method for max_threshold, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in bytes.
When the average queue length exceeds the maxth value, all packets are
dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold-percent and max-threshold-percent.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold(self):
    self.__max_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_min_threshold_percent(self):
    """
    Getter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    return self.__min_threshold_percent
      
  def _set_min_threshold_percent(self, v, load=False):
    """
    Setter method for min_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/min_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_min_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_min_threshold_percent() directly.

    YANG Description: The mininum threshold parameter for a RED-managed queue in percent.
When the average queue length is less than minth, all packets are
admitted to the queue.  Mutually exclusive with min-threshold and
max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """min_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__min_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_min_threshold_percent(self):
    self.__min_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="min-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_max_threshold_percent(self):
    """
    Getter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    return self.__max_threshold_percent
      
  def _set_max_threshold_percent(self, v, load=False):
    """
    Setter method for max_threshold_percent, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/max_threshold_percent (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_max_threshold_percent is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_max_threshold_percent() directly.

    YANG Description: The maximum threshold parameter for a RED-managed queue in percent.
When the average queue length exceeds the maxth value, all packets
are dropped (or marked if ECN is enabled).  Mutually exclusive with
min-threshold and max-threshold.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """max_threshold_percent must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)""",
        })

    self.__max_threshold_percent = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_max_threshold_percent(self):
    self.__max_threshold_percent = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="max-threshold-percent", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='uint64', is_config=True)


  def _get_enable_ecn(self):
    """
    Getter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    return self.__enable_ecn
      
  def _set_enable_ecn(self, v, load=False):
    """
    Setter method for enable_ecn, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/enable_ecn (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable_ecn is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable_ecn() directly.

    YANG Description: When this leaf is true and the number of packets in the queue
is between the minimum threshold and the maximum threshold, if
the ECN field on the packet indicates that the endpoints are ECN
capable (that is, the ECT bit is set to 1 and the CE bit is set
to 0, or the ECT bit is set to 0 and the CE bit is set to 1) and
the WRED algorithm determines that the packet should have been
dropped based on the drop probability, the ECT and CE bits for
the packet are changed to 1, and the packet is transmitted.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable_ecn must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__enable_ecn = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable_ecn(self):
    self.__enable_ecn = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="enable-ecn", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)


  def _get_drop(self):
    """
    Getter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    return self.__drop
      
  def _set_drop(self, v, load=False):
    """
    Setter method for drop, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/red/uniform/config/drop (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_drop is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_drop() directly.

    YANG Description: When this leaf is true and the packet and if the ECN field in
the packet indicates that the endpoints are not ECN capable and
the and the WRED algorithm determines that the packet should
have been dropped based on the drop probability, the packet
is dropped.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """drop must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)""",
        })

    self.__drop = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_drop(self):
    self.__drop = YANGDynClass(base=YANGBool, default=YANGBool("false"), is_leaf=True, yang_name="drop", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='boolean', is_config=True)

  min_threshold = __builtin__.property(_get_min_threshold, _set_min_threshold)
  max_threshold = __builtin__.property(_get_max_threshold, _set_max_threshold)
  min_threshold_percent = __builtin__.property(_get_min_threshold_percent, _set_min_threshold_percent)
  max_threshold_percent = __builtin__.property(_get_max_threshold_percent, _set_max_threshold_percent)
  enable_ecn = __builtin__.property(_get_enable_ecn, _set_enable_ecn)
  drop = __builtin__.property(_get_drop, _set_drop)


  _pyangbind_elements = OrderedDict([('min_threshold', min_threshold), ('max_threshold', max_threshold), ('min_threshold_percent', min_threshold_percent), ('max_threshold_percent', max_threshold_percent), ('enable_ecn', enable_ecn), ('drop', drop), ])


