# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-interfaces - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-elements - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


from . import uniform
class wred(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-qos-mem-mgmt - based on the path /qos/queue-management-profiles/queue-management-profile/wred. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
Weighted Random Early Detection (WRED).
  """
  __slots__ = ('_path_helper', '_extmethods', '__uniform',)

  _yang_name = 'wred'
  _yang_namespace = 'http://openconfig.net/yang/qos'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['qos', 'queue-management-profiles', 'queue-management-profile', 'wred']

  def _get_uniform(self):
    """
    Getter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    return self.__uniform
      
  def _set_uniform(self, v, load=False):
    """
    Setter method for uniform, mapped from YANG variable /qos/queue_management_profiles/queue_management_profile/wred/uniform (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_uniform is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_uniform() directly.

    YANG Description: Uniform WRED parameters. These parameters are applied to all the
traffic coming into system.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """uniform must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)""",
        })

    self.__uniform = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_uniform(self):
    self.__uniform = YANGDynClass(base=uniform.uniform, is_container='container', yang_name="uniform", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/qos', defining_module='openconfig-qos', yang_type='container', is_config=True)

  uniform = __builtin__.property(_get_uniform, _set_uniform)


  _pyangbind_elements = OrderedDict([('uniform', uniform), ])


