# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import as_path_set
class as_path_sets(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/defined-sets/bgp-defined-sets/as-path-sets. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for list of define AS path sets
  """
  __slots__ = ('_path_helper', '_extmethods', '__as_path_set',)

  _yang_name = 'as-path-sets'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__as_path_set = YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'defined-sets', 'bgp-defined-sets', 'as-path-sets']

  def _get_as_path_set(self):
    """
    Getter method for as_path_set, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set (list)

    YANG Description: List of defined AS path sets
    """
    return self.__as_path_set
      
  def _set_as_path_set(self, v, load=False):
    """
    Setter method for as_path_set, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set() directly.

    YANG Description: List of defined AS path sets
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)""",
        })

    self.__as_path_set = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set(self):
    self.__as_path_set = YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)

  as_path_set = __builtin__.property(_get_as_path_set, _set_as_path_set)


  _pyangbind_elements = OrderedDict([('as_path_set', as_path_set), ])


from . import as_path_set
class as_path_sets(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/defined-sets/bgp-defined-sets/as-path-sets. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Enclosing container for list of define AS path sets
  """
  __slots__ = ('_path_helper', '_extmethods', '__as_path_set',)

  _yang_name = 'as-path-sets'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__as_path_set = YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'defined-sets', 'bgp-defined-sets', 'as-path-sets']

  def _get_as_path_set(self):
    """
    Getter method for as_path_set, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set (list)

    YANG Description: List of defined AS path sets
    """
    return self.__as_path_set
      
  def _set_as_path_set(self, v, load=False):
    """
    Setter method for as_path_set, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set() directly.

    YANG Description: List of defined AS path sets
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)""",
        })

    self.__as_path_set = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set(self):
    self.__as_path_set = YANGDynClass(base=YANGListType("as_path_set_name",as_path_set.as_path_set, yang_name="as-path-set", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='as-path-set-name', extensions=None), is_container='list', yang_name="as-path-set", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='list', is_config=True)

  as_path_set = __builtin__.property(_get_as_path_set, _set_as_path_set)


  _pyangbind_elements = OrderedDict([('as_path_set', as_path_set), ])


