# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/defined-sets/bgp-defined-sets/as-path-sets/as-path-set/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for AS path sets
  """
  __slots__ = ('_path_helper', '_extmethods', '__as_path_set_name','__as_path_set_member',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__as_path_set_name = YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    self.__as_path_set_member = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'defined-sets', 'bgp-defined-sets', 'as-path-sets', 'as-path-set', 'state']

  def _get_as_path_set_name(self):
    """
    Getter method for as_path_set_name, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_name (string)

    YANG Description: name of the AS path set -- this is used to reference
the set in match conditions
    """
    return self.__as_path_set_name
      
  def _set_as_path_set_name(self, v, load=False):
    """
    Setter method for as_path_set_name, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set_name() directly.

    YANG Description: name of the AS path set -- this is used to reference
the set in match conditions
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)""",
        })

    self.__as_path_set_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set_name(self):
    self.__as_path_set_name = YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)


  def _get_as_path_set_member(self):
    """
    Getter method for as_path_set_member, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_member (string)

    YANG Description: AS path expression -- list of ASes in the set
    """
    return self.__as_path_set_member
      
  def _set_as_path_set_member(self, v, load=False):
    """
    Setter method for as_path_set_member, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_member (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set_member is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set_member() directly.

    YANG Description: AS path expression -- list of ASes in the set
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set_member must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)""",
        })

    self.__as_path_set_member = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set_member(self):
    self.__as_path_set_member = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)

  as_path_set_name = __builtin__.property(_get_as_path_set_name)
  as_path_set_member = __builtin__.property(_get_as_path_set_member)


  _pyangbind_elements = OrderedDict([('as_path_set_name', as_path_set_name), ('as_path_set_member', as_path_set_member), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/defined-sets/bgp-defined-sets/as-path-sets/as-path-set/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for AS path sets
  """
  __slots__ = ('_path_helper', '_extmethods', '__as_path_set_name','__as_path_set_member',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__as_path_set_name = YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    self.__as_path_set_member = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'defined-sets', 'bgp-defined-sets', 'as-path-sets', 'as-path-set', 'state']

  def _get_as_path_set_name(self):
    """
    Getter method for as_path_set_name, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_name (string)

    YANG Description: name of the AS path set -- this is used to reference
the set in match conditions
    """
    return self.__as_path_set_name
      
  def _set_as_path_set_name(self, v, load=False):
    """
    Setter method for as_path_set_name, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set_name() directly.

    YANG Description: name of the AS path set -- this is used to reference
the set in match conditions
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set_name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)""",
        })

    self.__as_path_set_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set_name(self):
    self.__as_path_set_name = YANGDynClass(base=str, is_leaf=True, yang_name="as-path-set-name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)


  def _get_as_path_set_member(self):
    """
    Getter method for as_path_set_member, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_member (string)

    YANG Description: AS path expression -- list of ASes in the set
    """
    return self.__as_path_set_member
      
  def _set_as_path_set_member(self, v, load=False):
    """
    Setter method for as_path_set_member, mapped from YANG variable /routing_policy/defined_sets/bgp_defined_sets/as_path_sets/as_path_set/state/as_path_set_member (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_as_path_set_member is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_as_path_set_member() directly.

    YANG Description: AS path expression -- list of ASes in the set
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """as_path_set_member must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)""",
        })

    self.__as_path_set_member = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_as_path_set_member(self):
    self.__as_path_set_member = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="as-path-set-member", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='string', is_config=False)

  as_path_set_name = __builtin__.property(_get_as_path_set_name)
  as_path_set_member = __builtin__.property(_get_as_path_set_member)


  _pyangbind_elements = OrderedDict([('as_path_set_name', as_path_set_name), ('as_path_set_member', as_path_set_member), ])


