# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/policy-definitions/policy-definition/statements/statement/actions/bgp-actions/set-ext-community/reference/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for referening an extended
community-set in the set-ext-community action
  """
  __slots__ = ('_path_helper', '_extmethods', '__ext_community_set_refs','__ext_community_set_ref',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ext_community_set_refs = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    self.__ext_community_set_ref = YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'policy-definitions', 'policy-definition', 'statements', 'statement', 'actions', 'bgp-actions', 'set-ext-community', 'reference', 'state']

  def _get_ext_community_set_refs(self):
    """
    Getter method for ext_community_set_refs, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_refs (leafref)

    YANG Description: References a list of defined extended community sets by
name
    """
    return self.__ext_community_set_refs
      
  def _set_ext_community_set_refs(self, v, load=False):
    """
    Setter method for ext_community_set_refs, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_refs (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ext_community_set_refs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ext_community_set_refs() directly.

    YANG Description: References a list of defined extended community sets by
name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ext_community_set_refs must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)""",
        })

    self.__ext_community_set_refs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ext_community_set_refs(self):
    self.__ext_community_set_refs = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)


  def _get_ext_community_set_ref(self):
    """
    Getter method for ext_community_set_ref, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_ref (leafref)

    YANG Description: References a defined extended community set by
name
    """
    return self.__ext_community_set_ref
      
  def _set_ext_community_set_ref(self, v, load=False):
    """
    Setter method for ext_community_set_ref, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_ref (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ext_community_set_ref is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ext_community_set_ref() directly.

    YANG Description: References a defined extended community set by
name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ext_community_set_ref must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)""",
        })

    self.__ext_community_set_ref = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ext_community_set_ref(self):
    self.__ext_community_set_ref = YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)

  ext_community_set_refs = __builtin__.property(_get_ext_community_set_refs)
  ext_community_set_ref = __builtin__.property(_get_ext_community_set_ref)


  _pyangbind_elements = OrderedDict([('ext_community_set_refs', ext_community_set_refs), ('ext_community_set_ref', ext_community_set_ref), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-routing-policy - based on the path /routing-policy/policy-definitions/policy-definition/statements/statement/actions/bgp-actions/set-ext-community/reference/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Operational state data for referening an extended
community-set in the set-ext-community action
  """
  __slots__ = ('_path_helper', '_extmethods', '__ext_community_set_refs','__ext_community_set_ref',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/routing-policy'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__ext_community_set_refs = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    self.__ext_community_set_ref = YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['routing-policy', 'policy-definitions', 'policy-definition', 'statements', 'statement', 'actions', 'bgp-actions', 'set-ext-community', 'reference', 'state']

  def _get_ext_community_set_refs(self):
    """
    Getter method for ext_community_set_refs, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_refs (leafref)

    YANG Description: References a list of defined extended community sets by
name
    """
    return self.__ext_community_set_refs
      
  def _set_ext_community_set_refs(self, v, load=False):
    """
    Setter method for ext_community_set_refs, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_refs (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ext_community_set_refs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ext_community_set_refs() directly.

    YANG Description: References a list of defined extended community sets by
name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ext_community_set_refs must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)""",
        })

    self.__ext_community_set_refs = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ext_community_set_refs(self):
    self.__ext_community_set_refs = YANGDynClass(unique=True, base=TypedListType(allowed_type=str), is_leaf=False, yang_name="ext-community-set-refs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)


  def _get_ext_community_set_ref(self):
    """
    Getter method for ext_community_set_ref, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_ref (leafref)

    YANG Description: References a defined extended community set by
name
    """
    return self.__ext_community_set_ref
      
  def _set_ext_community_set_ref(self, v, load=False):
    """
    Setter method for ext_community_set_ref, mapped from YANG variable /routing_policy/policy_definitions/policy_definition/statements/statement/actions/bgp_actions/set_ext_community/reference/state/ext_community_set_ref (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ext_community_set_ref is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ext_community_set_ref() directly.

    YANG Description: References a defined extended community set by
name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ext_community_set_ref must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)""",
        })

    self.__ext_community_set_ref = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ext_community_set_ref(self):
    self.__ext_community_set_ref = YANGDynClass(base=str, is_leaf=True, yang_name="ext-community-set-ref", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/bgp-policy', defining_module='openconfig-bgp-policy', yang_type='leafref', is_config=False)

  ext_community_set_refs = __builtin__.property(_get_ext_community_set_refs)
  ext_community_set_ref = __builtin__.property(_get_ext_community_set_ref)


  _pyangbind_elements = OrderedDict([('ext_community_set_refs', ext_community_set_refs), ('ext_community_set_ref', ext_community_set_ref), ])


