# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import source_records
class acctz(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/aaa/accounting/acctz. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters regarding the creation of gNSI.acctz records.
  """
  __slots__ = ('_path_helper', '_extmethods', '__source_records',)

  _yang_name = 'acctz'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__source_records = YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'aaa', 'accounting', 'acctz']

  def _get_source_records(self):
    """
    Getter method for source_records, mapped from YANG variable /system/aaa/accounting/acctz/source_records (container)

    YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
    """
    return self.__source_records
      
  def _set_source_records(self, v, load=False):
    """
    Setter method for source_records, mapped from YANG variable /system/aaa/accounting/acctz/source_records (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_records is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_records() directly.

    YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """source_records must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)""",
        })

    self.__source_records = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_source_records(self):
    self.__source_records = YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)

  source_records = __builtin__.property(_get_source_records)


  _pyangbind_elements = OrderedDict([('source_records', source_records), ])


from . import source_records
class acctz(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/aaa/accounting/acctz. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters regarding the creation of gNSI.acctz records.
  """
  __slots__ = ('_path_helper', '_extmethods', '__source_records',)

  _yang_name = 'acctz'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__source_records = YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'aaa', 'accounting', 'acctz']

  def _get_source_records(self):
    """
    Getter method for source_records, mapped from YANG variable /system/aaa/accounting/acctz/source_records (container)

    YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
    """
    return self.__source_records
      
  def _set_source_records(self, v, load=False):
    """
    Setter method for source_records, mapped from YANG variable /system/aaa/accounting/acctz/source_records (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_records is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_records() directly.

    YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """source_records must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)""",
        })

    self.__source_records = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_source_records(self):
    self.__source_records = YANGDynClass(base=source_records.source_records, is_container='container', yang_name="source-records", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='container', is_config=False)

  source_records = __builtin__.property(_get_source_records)


  _pyangbind_elements = OrderedDict([('source_records', source_records), ])


