# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import source_record
class source_records(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/aaa/accounting/acctz/source-records. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__source_record',)

  _yang_name = 'source-records'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__source_record = YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'aaa', 'accounting', 'acctz', 'source-records']

  def _get_source_record(self):
    """
    Getter method for source_record, mapped from YANG variable /system/aaa/accounting/acctz/source_records/source_record (list)

    YANG Description: A collection of counters for each service request type.
    """
    return self.__source_record
      
  def _set_source_record(self, v, load=False):
    """
    Setter method for source_record, mapped from YANG variable /system/aaa/accounting/acctz/source_records/source_record (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_record is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_record() directly.

    YANG Description: A collection of counters for each service request type.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """source_record must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)""",
        })

    self.__source_record = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_source_record(self):
    self.__source_record = YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)

  source_record = __builtin__.property(_get_source_record)


  _pyangbind_elements = OrderedDict([('source_record', source_record), ])


from . import source_record
class source_records(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/aaa/accounting/acctz/source-records. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters for gNSI.acctz record production per
service request type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__source_record',)

  _yang_name = 'source-records'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__source_record = YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'aaa', 'accounting', 'acctz', 'source-records']

  def _get_source_record(self):
    """
    Getter method for source_record, mapped from YANG variable /system/aaa/accounting/acctz/source_records/source_record (list)

    YANG Description: A collection of counters for each service request type.
    """
    return self.__source_record
      
  def _set_source_record(self, v, load=False):
    """
    Setter method for source_record, mapped from YANG variable /system/aaa/accounting/acctz/source_records/source_record (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_record is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_record() directly.

    YANG Description: A collection of counters for each service request type.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """source_record must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)""",
        })

    self.__source_record = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_source_record(self):
    self.__source_record = YANGDynClass(base=YANGListType("service type",source_record.source_record, yang_name="source-record", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='service type', extensions=None), is_container='list', yang_name="source-record", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/acctz', defining_module='openconfig-gnsi-acctz', yang_type='list', is_config=False)

  source_record = __builtin__.property(_get_source_record)


  _pyangbind_elements = OrderedDict([('source_record', source_record), ])


