# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
from . import rpc
class rpcs(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/grpc-servers/grpc-server/authz-policy-counters/rpcs. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters collected by the gNSI.authz module
for each RPC separately.
  """
  __slots__ = ('_path_helper', '_extmethods', '__rpc',)

  _yang_name = 'rpcs'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__rpc = YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'grpc-servers', 'grpc-server', 'authz-policy-counters', 'rpcs']

  def _get_rpc(self):
    """
    Getter method for rpc, mapped from YANG variable /system/grpc_servers/grpc_server/authz_policy_counters/rpcs/rpc (list)

    YANG Description: A collection of counters collected by the gNSI.authz module
for a RPC identified by the `name`.
    """
    return self.__rpc
      
  def _set_rpc(self, v, load=False):
    """
    Setter method for rpc, mapped from YANG variable /system/grpc_servers/grpc_server/authz_policy_counters/rpcs/rpc (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_rpc is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_rpc() directly.

    YANG Description: A collection of counters collected by the gNSI.authz module
for a RPC identified by the `name`.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """rpc must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)""",
        })

    self.__rpc = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_rpc(self):
    self.__rpc = YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)

  rpc = __builtin__.property(_get_rpc)


  _pyangbind_elements = OrderedDict([('rpc', rpc), ])


from . import rpc
class rpcs(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-system - based on the path /system/grpc-servers/grpc-server/authz-policy-counters/rpcs. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: A collection of counters collected by the gNSI.authz module
for each RPC separately.
  """
  __slots__ = ('_path_helper', '_extmethods', '__rpc',)

  _yang_name = 'rpcs'
  _yang_namespace = 'http://openconfig.net/yang/system'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__rpc = YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['system', 'grpc-servers', 'grpc-server', 'authz-policy-counters', 'rpcs']

  def _get_rpc(self):
    """
    Getter method for rpc, mapped from YANG variable /system/grpc_servers/grpc_server/authz_policy_counters/rpcs/rpc (list)

    YANG Description: A collection of counters collected by the gNSI.authz module
for a RPC identified by the `name`.
    """
    return self.__rpc
      
  def _set_rpc(self, v, load=False):
    """
    Setter method for rpc, mapped from YANG variable /system/grpc_servers/grpc_server/authz_policy_counters/rpcs/rpc (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_rpc is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_rpc() directly.

    YANG Description: A collection of counters collected by the gNSI.authz module
for a RPC identified by the `name`.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """rpc must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)""",
        })

    self.__rpc = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_rpc(self):
    self.__rpc = YANGDynClass(base=YANGListType("name",rpc.rpc, yang_name="rpc", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name', extensions=None), is_container='list', yang_name="rpc", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='https://github.com/openconfig/yang/gnsi/authz', defining_module='openconfig-gnsi-authz', yang_type='list', is_config=False)

  rpc = __builtin__.property(_get_rpc)


  _pyangbind_elements = OrderedDict([('rpc', rpc), ])


