# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-telemetry - based on the path /telemetry-system/sensor-groups/sensor-group/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
telemetry sensor grouping
  """
  __slots__ = ('_path_helper', '_extmethods', '__sensor_group_id',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/telemetry'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__sensor_group_id = YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['telemetry-system', 'sensor-groups', 'sensor-group', 'config']

  def _get_sensor_group_id(self):
    """
    Getter method for sensor_group_id, mapped from YANG variable /telemetry_system/sensor_groups/sensor_group/config/sensor_group_id (string)

    YANG Description: Name or identifier for the sensor group itself.
Will be referenced by other configuration specifying a
sensor group
    """
    return self.__sensor_group_id
      
  def _set_sensor_group_id(self, v, load=False):
    """
    Setter method for sensor_group_id, mapped from YANG variable /telemetry_system/sensor_groups/sensor_group/config/sensor_group_id (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_sensor_group_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_sensor_group_id() directly.

    YANG Description: Name or identifier for the sensor group itself.
Will be referenced by other configuration specifying a
sensor group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """sensor_group_id must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)""",
        })

    self.__sensor_group_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_sensor_group_id(self):
    self.__sensor_group_id = YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)

  sensor_group_id = __builtin__.property(_get_sensor_group_id, _set_sensor_group_id)


  _pyangbind_elements = OrderedDict([('sensor_group_id', sensor_group_id), ])


class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-telemetry - based on the path /telemetry-system/sensor-groups/sensor-group/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to the
telemetry sensor grouping
  """
  __slots__ = ('_path_helper', '_extmethods', '__sensor_group_id',)

  _yang_name = 'config'
  _yang_namespace = 'http://openconfig.net/yang/telemetry'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__sensor_group_id = YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['telemetry-system', 'sensor-groups', 'sensor-group', 'config']

  def _get_sensor_group_id(self):
    """
    Getter method for sensor_group_id, mapped from YANG variable /telemetry_system/sensor_groups/sensor_group/config/sensor_group_id (string)

    YANG Description: Name or identifier for the sensor group itself.
Will be referenced by other configuration specifying a
sensor group
    """
    return self.__sensor_group_id
      
  def _set_sensor_group_id(self, v, load=False):
    """
    Setter method for sensor_group_id, mapped from YANG variable /telemetry_system/sensor_groups/sensor_group/config/sensor_group_id (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_sensor_group_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_sensor_group_id() directly.

    YANG Description: Name or identifier for the sensor group itself.
Will be referenced by other configuration specifying a
sensor group
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """sensor_group_id must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)""",
        })

    self.__sensor_group_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_sensor_group_id(self):
    self.__sensor_group_id = YANGDynClass(base=str, is_leaf=True, yang_name="sensor-group-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='string', is_config=True)

  sensor_group_id = __builtin__.property(_get_sensor_group_id, _set_sensor_group_id)


  _pyangbind_elements = OrderedDict([('sensor_group_id', sensor_group_id), ])


