# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.yangtypes import YANGBinary
from pyangbind.lib.yangtypes import YANGBitsType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal

import builtins as __builtin__
long = int
class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-telemetry - based on the path /telemetry-system/subscriptions/dynamic-subscriptions/dynamic-subscription/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State information relating to dynamic telemetry
subscriptions.
  """
  __slots__ = ('_path_helper', '_extmethods', '__id','__destination_address','__destination_port','__sample_interval','__heartbeat_interval','__suppress_redundant','__originated_qos_marking','__protocol','__encoding',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/telemetry'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__destination_address = YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)
    self.__destination_port = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)
    self.__sample_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__heartbeat_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__suppress_redundant = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)
    self.__originated_qos_marking = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)
    self.__protocol = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    self.__encoding = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['telemetry-system', 'subscriptions', 'dynamic-subscriptions', 'dynamic-subscription', 'state']

  def _get_id(self):
    """
    Getter method for id, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/id (uint64)

    YANG Description: System generated identifer of the telemetry
subscription.
    """
    return self.__id
      
  def _set_id(self, v, load=False):
    """
    Setter method for id, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/id (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_id() directly.

    YANG Description: System generated identifer of the telemetry
subscription.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """id must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_id(self):
    self.__id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_destination_address(self):
    """
    Getter method for destination_address, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_address (oc-inet:ip-address)

    YANG Description: IP address of the telemetry stream destination
    """
    return self.__destination_address
      
  def _set_destination_address(self, v, load=False):
    """
    Setter method for destination_address, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_address (oc-inet:ip-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_address() directly.

    YANG Description: IP address of the telemetry stream destination
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """destination_address must be of a type compatible with oc-inet:ip-address""",
          'defined-type': "oc-inet:ip-address",
          'generated-type': """YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)""",
        })

    self.__destination_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_destination_address(self):
    self.__destination_address = YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)


  def _get_destination_port(self):
    """
    Getter method for destination_port, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_port (uint16)

    YANG Description: Protocol (udp or tcp) port number for the telemetry
stream destination
    """
    return self.__destination_port
      
  def _set_destination_port(self, v, load=False):
    """
    Setter method for destination_port, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_port (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_port is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_port() directly.

    YANG Description: Protocol (udp or tcp) port number for the telemetry
stream destination
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """destination_port must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)""",
        })

    self.__destination_port = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_destination_port(self):
    self.__destination_port = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)


  def _get_sample_interval(self):
    """
    Getter method for sample_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/sample_interval (uint64)

    YANG Description: Time in milliseconds between the device's sample of a
telemetry data source. For example, setting this to 100
would require the local device to collect the telemetry
data every 100 milliseconds. There can be latency or jitter
in transmitting the data, but the sample must occur at
the specified interval.

The timestamp must reflect the actual time when the data
was sampled, not simply the previous sample timestamp +
sample-interval.

If sample-interval is set to 0, the telemetry sensor
becomes event based. The sensor must then emit data upon
every change of the underlying data source.
    """
    return self.__sample_interval
      
  def _set_sample_interval(self, v, load=False):
    """
    Setter method for sample_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/sample_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_sample_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_sample_interval() directly.

    YANG Description: Time in milliseconds between the device's sample of a
telemetry data source. For example, setting this to 100
would require the local device to collect the telemetry
data every 100 milliseconds. There can be latency or jitter
in transmitting the data, but the sample must occur at
the specified interval.

The timestamp must reflect the actual time when the data
was sampled, not simply the previous sample timestamp +
sample-interval.

If sample-interval is set to 0, the telemetry sensor
becomes event based. The sensor must then emit data upon
every change of the underlying data source.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """sample_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__sample_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_sample_interval(self):
    self.__sample_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_heartbeat_interval(self):
    """
    Getter method for heartbeat_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/heartbeat_interval (uint64)

    YANG Description: Maximum time interval in seconds that may pass
between updates from a device to a telemetry collector.
If this interval expires, but there is no updated data to
send (such as if suppress_updates has been configured), the
device must send a telemetry message to the collector.
    """
    return self.__heartbeat_interval
      
  def _set_heartbeat_interval(self, v, load=False):
    """
    Setter method for heartbeat_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/heartbeat_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_heartbeat_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_heartbeat_interval() directly.

    YANG Description: Maximum time interval in seconds that may pass
between updates from a device to a telemetry collector.
If this interval expires, but there is no updated data to
send (such as if suppress_updates has been configured), the
device must send a telemetry message to the collector.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """heartbeat_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__heartbeat_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_heartbeat_interval(self):
    self.__heartbeat_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_suppress_redundant(self):
    """
    Getter method for suppress_redundant, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/suppress_redundant (boolean)

    YANG Description: Boolean flag to control suppression of redundant
telemetry updates to the collector platform. If this flag is
set to TRUE, then the collector will only send an update at
the configured interval if a subscribed data value has
changed. Otherwise, the device will not send an update to
the collector until expiration of the heartbeat interval.
    """
    return self.__suppress_redundant
      
  def _set_suppress_redundant(self, v, load=False):
    """
    Setter method for suppress_redundant, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/suppress_redundant (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_suppress_redundant is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_suppress_redundant() directly.

    YANG Description: Boolean flag to control suppression of redundant
telemetry updates to the collector platform. If this flag is
set to TRUE, then the collector will only send an update at
the configured interval if a subscribed data value has
changed. Otherwise, the device will not send an update to
the collector until expiration of the heartbeat interval.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """suppress_redundant must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)""",
        })

    self.__suppress_redundant = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_suppress_redundant(self):
    self.__suppress_redundant = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)


  def _get_originated_qos_marking(self):
    """
    Getter method for originated_qos_marking, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/originated_qos_marking (oc-inet:dscp)

    YANG Description: DSCP marking of packets generated by the telemetry
subsystem on the network device.
    """
    return self.__originated_qos_marking
      
  def _set_originated_qos_marking(self, v, load=False):
    """
    Setter method for originated_qos_marking, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/originated_qos_marking (oc-inet:dscp)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_originated_qos_marking is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_originated_qos_marking() directly.

    YANG Description: DSCP marking of packets generated by the telemetry
subsystem on the network device.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """originated_qos_marking must be of a type compatible with oc-inet:dscp""",
          'defined-type': "oc-inet:dscp",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)""",
        })

    self.__originated_qos_marking = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_originated_qos_marking(self):
    self.__originated_qos_marking = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)


  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/protocol (identityref)

    YANG Description: Selection of the transport protocol for the telemetry
stream.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/protocol (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Selection of the transport protocol for the telemetry
stream.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with identityref""",
          'defined-type': "openconfig-telemetry:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)


  def _get_encoding(self):
    """
    Getter method for encoding, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/encoding (identityref)

    YANG Description: Selection of the specific encoding or RPC framework
for telemetry messages to and from the network element.
    """
    return self.__encoding
      
  def _set_encoding(self, v, load=False):
    """
    Setter method for encoding, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/encoding (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encoding is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encoding() directly.

    YANG Description: Selection of the specific encoding or RPC framework
for telemetry messages to and from the network element.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encoding must be of a type compatible with identityref""",
          'defined-type': "openconfig-telemetry:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)""",
        })

    self.__encoding = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encoding(self):
    self.__encoding = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)

  id = __builtin__.property(_get_id)
  destination_address = __builtin__.property(_get_destination_address)
  destination_port = __builtin__.property(_get_destination_port)
  sample_interval = __builtin__.property(_get_sample_interval)
  heartbeat_interval = __builtin__.property(_get_heartbeat_interval)
  suppress_redundant = __builtin__.property(_get_suppress_redundant)
  originated_qos_marking = __builtin__.property(_get_originated_qos_marking)
  protocol = __builtin__.property(_get_protocol)
  encoding = __builtin__.property(_get_encoding)


  _pyangbind_elements = OrderedDict([('id', id), ('destination_address', destination_address), ('destination_port', destination_port), ('sample_interval', sample_interval), ('heartbeat_interval', heartbeat_interval), ('suppress_redundant', suppress_redundant), ('originated_qos_marking', originated_qos_marking), ('protocol', protocol), ('encoding', encoding), ])


class state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-telemetry - based on the path /telemetry-system/subscriptions/dynamic-subscriptions/dynamic-subscription/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State information relating to dynamic telemetry
subscriptions.
  """
  __slots__ = ('_path_helper', '_extmethods', '__id','__destination_address','__destination_port','__sample_interval','__heartbeat_interval','__suppress_redundant','__originated_qos_marking','__protocol','__encoding',)

  _yang_name = 'state'
  _yang_namespace = 'http://openconfig.net/yang/telemetry'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__destination_address = YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)
    self.__destination_port = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)
    self.__sample_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__heartbeat_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    self.__suppress_redundant = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)
    self.__originated_qos_marking = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)
    self.__protocol = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    self.__encoding = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return ['telemetry-system', 'subscriptions', 'dynamic-subscriptions', 'dynamic-subscription', 'state']

  def _get_id(self):
    """
    Getter method for id, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/id (uint64)

    YANG Description: System generated identifer of the telemetry
subscription.
    """
    return self.__id
      
  def _set_id(self, v, load=False):
    """
    Setter method for id, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/id (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_id() directly.

    YANG Description: System generated identifer of the telemetry
subscription.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """id must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_id(self):
    self.__id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_destination_address(self):
    """
    Getter method for destination_address, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_address (oc-inet:ip-address)

    YANG Description: IP address of the telemetry stream destination
    """
    return self.__destination_address
      
  def _set_destination_address(self, v, load=False):
    """
    Setter method for destination_address, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_address (oc-inet:ip-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_address() directly.

    YANG Description: IP address of the telemetry stream destination
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """destination_address must be of a type compatible with oc-inet:ip-address""",
          'defined-type': "oc-inet:ip-address",
          'generated-type': """YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)""",
        })

    self.__destination_address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_destination_address(self):
    self.__destination_address = YANGDynClass(base=[RestrictedClassType(base_type=str, restriction_dict={'pattern': '([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}'}),RestrictedClassType(base_type=str, restriction_dict={'pattern': '(([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))'}),], is_leaf=True, yang_name="destination-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:ip-address', is_config=False)


  def _get_destination_port(self):
    """
    Getter method for destination_port, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_port (uint16)

    YANG Description: Protocol (udp or tcp) port number for the telemetry
stream destination
    """
    return self.__destination_port
      
  def _set_destination_port(self, v, load=False):
    """
    Setter method for destination_port, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/destination_port (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_port is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_port() directly.

    YANG Description: Protocol (udp or tcp) port number for the telemetry
stream destination
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """destination_port must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)""",
        })

    self.__destination_port = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_destination_port(self):
    self.__destination_port = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="destination-port", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint16', is_config=False)


  def _get_sample_interval(self):
    """
    Getter method for sample_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/sample_interval (uint64)

    YANG Description: Time in milliseconds between the device's sample of a
telemetry data source. For example, setting this to 100
would require the local device to collect the telemetry
data every 100 milliseconds. There can be latency or jitter
in transmitting the data, but the sample must occur at
the specified interval.

The timestamp must reflect the actual time when the data
was sampled, not simply the previous sample timestamp +
sample-interval.

If sample-interval is set to 0, the telemetry sensor
becomes event based. The sensor must then emit data upon
every change of the underlying data source.
    """
    return self.__sample_interval
      
  def _set_sample_interval(self, v, load=False):
    """
    Setter method for sample_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/sample_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_sample_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_sample_interval() directly.

    YANG Description: Time in milliseconds between the device's sample of a
telemetry data source. For example, setting this to 100
would require the local device to collect the telemetry
data every 100 milliseconds. There can be latency or jitter
in transmitting the data, but the sample must occur at
the specified interval.

The timestamp must reflect the actual time when the data
was sampled, not simply the previous sample timestamp +
sample-interval.

If sample-interval is set to 0, the telemetry sensor
becomes event based. The sensor must then emit data upon
every change of the underlying data source.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """sample_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__sample_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_sample_interval(self):
    self.__sample_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="sample-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_heartbeat_interval(self):
    """
    Getter method for heartbeat_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/heartbeat_interval (uint64)

    YANG Description: Maximum time interval in seconds that may pass
between updates from a device to a telemetry collector.
If this interval expires, but there is no updated data to
send (such as if suppress_updates has been configured), the
device must send a telemetry message to the collector.
    """
    return self.__heartbeat_interval
      
  def _set_heartbeat_interval(self, v, load=False):
    """
    Setter method for heartbeat_interval, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/heartbeat_interval (uint64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_heartbeat_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_heartbeat_interval() directly.

    YANG Description: Maximum time interval in seconds that may pass
between updates from a device to a telemetry collector.
If this interval expires, but there is no updated data to
send (such as if suppress_updates has been configured), the
device must send a telemetry message to the collector.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """heartbeat_interval must be of a type compatible with uint64""",
          'defined-type': "uint64",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)""",
        })

    self.__heartbeat_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_heartbeat_interval(self):
    self.__heartbeat_interval = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range':  ['0..18446744073709551615']}, int_size=64), is_leaf=True, yang_name="heartbeat-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='uint64', is_config=False)


  def _get_suppress_redundant(self):
    """
    Getter method for suppress_redundant, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/suppress_redundant (boolean)

    YANG Description: Boolean flag to control suppression of redundant
telemetry updates to the collector platform. If this flag is
set to TRUE, then the collector will only send an update at
the configured interval if a subscribed data value has
changed. Otherwise, the device will not send an update to
the collector until expiration of the heartbeat interval.
    """
    return self.__suppress_redundant
      
  def _set_suppress_redundant(self, v, load=False):
    """
    Setter method for suppress_redundant, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/suppress_redundant (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_suppress_redundant is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_suppress_redundant() directly.

    YANG Description: Boolean flag to control suppression of redundant
telemetry updates to the collector platform. If this flag is
set to TRUE, then the collector will only send an update at
the configured interval if a subscribed data value has
changed. Otherwise, the device will not send an update to
the collector until expiration of the heartbeat interval.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """suppress_redundant must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)""",
        })

    self.__suppress_redundant = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_suppress_redundant(self):
    self.__suppress_redundant = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="suppress-redundant", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='boolean', is_config=False)


  def _get_originated_qos_marking(self):
    """
    Getter method for originated_qos_marking, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/originated_qos_marking (oc-inet:dscp)

    YANG Description: DSCP marking of packets generated by the telemetry
subsystem on the network device.
    """
    return self.__originated_qos_marking
      
  def _set_originated_qos_marking(self, v, load=False):
    """
    Setter method for originated_qos_marking, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/originated_qos_marking (oc-inet:dscp)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_originated_qos_marking is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_originated_qos_marking() directly.

    YANG Description: DSCP marking of packets generated by the telemetry
subsystem on the network device.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """originated_qos_marking must be of a type compatible with oc-inet:dscp""",
          'defined-type': "oc-inet:dscp",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)""",
        })

    self.__originated_qos_marking = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_originated_qos_marking(self):
    self.__originated_qos_marking = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="originated-qos-marking", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='oc-inet:dscp', is_config=False)


  def _get_protocol(self):
    """
    Getter method for protocol, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/protocol (identityref)

    YANG Description: Selection of the transport protocol for the telemetry
stream.
    """
    return self.__protocol
      
  def _set_protocol(self, v, load=False):
    """
    Setter method for protocol, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/protocol (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Selection of the transport protocol for the telemetry
stream.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """protocol must be of a type compatible with identityref""",
          'defined-type': "openconfig-telemetry:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)""",
        })

    self.__protocol = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_protocol(self):
    self.__protocol = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_SSH': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_GRPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_JSON_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_THRIFT_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:STREAM_WEBSOCKET_RPC': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)


  def _get_encoding(self):
    """
    Getter method for encoding, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/encoding (identityref)

    YANG Description: Selection of the specific encoding or RPC framework
for telemetry messages to and from the network element.
    """
    return self.__encoding
      
  def _set_encoding(self, v, load=False):
    """
    Setter method for encoding, mapped from YANG variable /telemetry_system/subscriptions/dynamic_subscriptions/dynamic_subscription/state/encoding (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_encoding is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_encoding() directly.

    YANG Description: Selection of the specific encoding or RPC framework
for telemetry messages to and from the network element.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """encoding must be of a type compatible with identityref""",
          'defined-type': "openconfig-telemetry:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)""",
        })

    self.__encoding = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_encoding(self):
    self.__encoding = YANGDynClass(base=RestrictedClassType(base_type=str, restriction_type="dict_key", restriction_arg={'ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_XML': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_JSON_IETF': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'openconfig-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}, 'oc-telemetry-types:ENC_PROTO3': {'@module': 'openconfig-telemetry-types', '@namespace': 'http://openconfig.net/yang/telemetry-types'}},), is_leaf=True, yang_name="encoding", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/telemetry', defining_module='openconfig-telemetry', yang_type='identityref', is_config=False)

  id = __builtin__.property(_get_id)
  destination_address = __builtin__.property(_get_destination_address)
  destination_port = __builtin__.property(_get_destination_port)
  sample_interval = __builtin__.property(_get_sample_interval)
  heartbeat_interval = __builtin__.property(_get_heartbeat_interval)
  suppress_redundant = __builtin__.property(_get_suppress_redundant)
  originated_qos_marking = __builtin__.property(_get_originated_qos_marking)
  protocol = __builtin__.property(_get_protocol)
  encoding = __builtin__.property(_get_encoding)


  _pyangbind_elements = OrderedDict([('id', id), ('destination_address', destination_address), ('destination_port', destination_port), ('sample_interval', sample_interval), ('heartbeat_interval', heartbeat_interval), ('suppress_redundant', suppress_redundant), ('originated_qos_marking', originated_qos_marking), ('protocol', protocol), ('encoding', encoding), ])


